"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppModule = void 0;
const common_1 = require("@nestjs/common");
const serve_static_1 = require("@nestjs/serve-static");
const path_1 = require("path");
const cors = require("cors");
require("dotenv/config");
const app_controller_1 = require("./app.controller");
const app_service_1 = require("./app.service");
const users_module_1 = require("./users/users.module");
const typeorm_1 = require("@nestjs/typeorm");
const perfil_module_1 = require("./perfil/perfil.module");
const tipo_vista_module_1 = require("./tipo-vista/tipo-vista.module");
const vista_module_1 = require("./vista/vista.module");
const tipo_vivienda_module_1 = require("./tipo-vivienda/tipo-vivienda.module");
const tipo_operacion_module_1 = require("./tipo-operacion/tipo-operacion.module");
const estado_inmueble_module_1 = require("./estado-inmueble/estado-inmueble.module");
const tipo_inmueble_module_1 = require("./tipo-inmueble/tipo-inmueble.module");
const nivel_amoblado_module_1 = require("./nivel-amoblado/nivel-amoblado.module");
const estado_proyecto_module_1 = require("./estado-proyecto/estado-proyecto.module");
const pais_module_1 = require("./pais/pais.module");
const departamento_module_1 = require("./departamento/departamento.module");
const provincia_module_1 = require("./provincia/provincia.module");
const distrito_module_1 = require("./distrito/distrito.module");
const inmueble_module_1 = require("./inmueble/inmueble.module");
const areas_sociales_module_1 = require("./areas-sociales/areas-sociales.module");
const favoritos_module_1 = require("./favoritos/favoritos.module");
const busquedas_module_1 = require("./busquedas/busquedas.module");
const galeria_module_1 = require("./galeria/galeria.module");
const inmueble_areas_sociales_module_1 = require("./inmueble-areas-sociales/inmueble-areas-sociales.module");
const tipo_ubicacion_module_1 = require("./tipo-ubicacion/tipo-ubicacion.module");
const unique_validators_1 = require("./users/unique-validators");
const inmueble_estados_module_1 = require("./inmueble-estados/inmueble-estados.module");
const inmueble_vistas_module_1 = require("./inmueble-vistas/inmueble-vistas.module");
const tipo_moneda_module_1 = require("./tipo-moneda/tipo-moneda.module");
const estado_module_1 = require("./estado/estado.module");
const inmueble_web_module_1 = require("./inmueble-web/inmueble-web.module");
let AppModule = class AppModule {
    configure(consumer) {
        consumer
            .apply(cors({
            origin: 'http://yobusco.pe',
            methods: 'GET,HEAD,PUT,PATCH,POST,DELETE',
            credentials: true,
        }))
            .forRoutes('*');
    }
};
exports.AppModule = AppModule;
exports.AppModule = AppModule = __decorate([
    (0, common_1.Module)({
        imports: [
            serve_static_1.ServeStaticModule.forRoot({
                rootPath: (0, path_1.join)(__dirname, '..', 'upload'),
                serveRoot: '/upload',
                exclude: ['*'],
            }),
            serve_static_1.ServeStaticModule.forRoot({
                rootPath: (0, path_1.join)(__dirname, '..', 'upload/fileImageUser'),
                serveRoot: '/upload',
                exclude: ['*'],
            }),
            serve_static_1.ServeStaticModule.forRoot({
                rootPath: (0, path_1.join)(__dirname, '..', 'images'),
                serveRoot: '/images',
                exclude: ['*'],
            }),
            serve_static_1.ServeStaticModule.forRoot({
                rootPath: (0, path_1.join)(__dirname, '..', 'images/user'),
                serveRoot: '/images',
                exclude: ['*'],
            }),
            typeorm_1.TypeOrmModule.forRoot({
                type: 'mysql',
                host: process.env.DATABASE_HOST,
                port: 3306,
                username: process.env.DATABASE_USERNAME,
                password: process.env.DATABASE_PASSWORD,
                database: process.env.DATABASE_NAME,
                entities: [__dirname + '/**/*.entity{.ts,.js}']
            }),
            users_module_1.UsersModule,
            perfil_module_1.PerfilModule,
            tipo_vista_module_1.TipoVistaModule,
            vista_module_1.VistaModule,
            tipo_vivienda_module_1.TipoViviendaModule,
            tipo_operacion_module_1.TipoOperacionModule,
            estado_inmueble_module_1.EstadoInmuebleModule,
            tipo_inmueble_module_1.TipoInmuebleModule,
            nivel_amoblado_module_1.NivelAmobladoModule,
            estado_proyecto_module_1.EstadoProyectoModule,
            pais_module_1.PaisModule,
            departamento_module_1.DepartamentoModule,
            provincia_module_1.ProvinciaModule,
            distrito_module_1.DistritoModule,
            inmueble_module_1.InmuebleModule,
            areas_sociales_module_1.AreasSocialesModule,
            favoritos_module_1.FavoritosModule,
            busquedas_module_1.BusquedasModule,
            galeria_module_1.GaleriaModule,
            inmueble_areas_sociales_module_1.InmuebleAreasSocialesModule,
            tipo_ubicacion_module_1.TipoUbicacionModule,
            inmueble_estados_module_1.InmuebleEstadosModule,
            inmueble_vistas_module_1.InmuebleVistasModule,
            tipo_moneda_module_1.TipoMonedaModule,
            estado_module_1.EstadoModule,
            inmueble_web_module_1.InmuebleWebModule
        ],
        controllers: [app_controller_1.AppController],
        providers: [app_service_1.AppService, unique_validators_1.IsEmailUniqueConstraint],
    })
], AppModule);
//# sourceMappingURL=app.module.js.map