"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AreasSocialesController = void 0;
const common_1 = require("@nestjs/common");
const areas_sociales_service_1 = require("./areas-sociales.service");
const create_areas_sociales_dto_1 = require("./dto/create-areas-sociales.dto");
const update_areas_sociales_dto_1 = require("./dto/update-areas-sociales.dto");
const common_2 = require("@nestjs/common");
const auth_guard_1 = require("../auth/auth.guard");
let AreasSocialesController = class AreasSocialesController {
    constructor(areasSocialesService) {
        this.areasSocialesService = areasSocialesService;
    }
    async getAreasSocialesSinInmueble(inmueble_id) {
        try {
            const data = await this.areasSocialesService.getDataSinInmueble(inmueble_id);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener perfiles', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getAreasSocialesAll() {
        try {
            const data = await this.areasSocialesService.getDataAll();
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener perfiles', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getAreasSociales(page, limit) {
        if (page <= 0 || limit <= 0) {
            throw new common_1.HttpException('Los valores de página y límite deben ser mayores que 0', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.areasSocialesService.getData(page, limit);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener datos', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getUserSearch(page, limit, body) {
        try {
            const { nombre } = body;
            console.log('Parámetros recibidos:', body);
            const data = await this.areasSocialesService.searchData(page, limit, {
                nombre
            });
            return {
                data,
            };
        }
        catch (error) {
            console.error('Error al buscar estado proyecto:', error);
            throw new common_1.HttpException(error.message || 'Ocurrió un error al procesar la solicitud', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    getAreasSocialesById(id) {
        console.log(id);
        console.log(typeof id);
        return this.areasSocialesService.getDataById(id);
    }
    createAreasSociales(newAreasSociales) {
        return this.areasSocialesService.createData(newAreasSociales);
    }
    updateAreasSociales(id, areasSociales) {
        return this.areasSocialesService.updateData(id, areasSociales);
    }
    deleteAreasSociales(id) {
        return this.areasSocialesService.deleteData(id);
    }
};
exports.AreasSocialesController = AreasSocialesController;
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)('areasSocialesSinInmueble/:inmueble_id'),
    __param(0, (0, common_1.Param)('inmueble_id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], AreasSocialesController.prototype, "getAreasSocialesSinInmueble", null);
__decorate([
    (0, common_1.Get)('areasSocialesAll'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AreasSocialesController.prototype, "getAreasSocialesAll", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], AreasSocialesController.prototype, "getAreasSociales", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)('searchAreasSociales/:page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", Promise)
], AreasSocialesController.prototype, "getUserSearch", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AreasSocialesController.prototype, "getAreasSocialesById", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_areas_sociales_dto_1.CreateAreasSocialesDto]),
    __metadata("design:returntype", void 0)
], AreasSocialesController.prototype, "createAreasSociales", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_areas_sociales_dto_1.UpdateAreasSocialesDto]),
    __metadata("design:returntype", void 0)
], AreasSocialesController.prototype, "updateAreasSociales", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AreasSocialesController.prototype, "deleteAreasSociales", null);
exports.AreasSocialesController = AreasSocialesController = __decorate([
    (0, common_1.Controller)('areas-sociales'),
    __metadata("design:paramtypes", [areas_sociales_service_1.AreasSocialesService])
], AreasSocialesController);
//# sourceMappingURL=areas-sociales.controller.js.map