"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BusquedasController = void 0;
const common_1 = require("@nestjs/common");
const busquedas_service_1 = require("./busquedas.service");
const create_busquedas_dto_1 = require("./dto/create-busquedas.dto");
const update_busquedas_dto_1 = require("./dto/update-busquedas.dto");
const common_2 = require("@nestjs/common");
const auth_guard_1 = require("../auth/auth.guard");
let BusquedasController = class BusquedasController {
    constructor(busquedasService) {
        this.busquedasService = busquedasService;
    }
    get() {
        return this.busquedasService.getData();
    }
    getBusquedaById(id) {
        console.log(id);
        console.log(typeof id);
        return this.busquedasService.getDataById(id);
    }
    createBusqueda(newBusqueda) {
        return this.busquedasService.createData(newBusqueda);
    }
    updateBusqueda(id, busqueda) {
        return this.busquedasService.updateData(id, busqueda);
    }
    deleteBusqueda(id) {
        return this.busquedasService.deleteData(id);
    }
};
exports.BusquedasController = BusquedasController;
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BusquedasController.prototype, "get", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BusquedasController.prototype, "getBusquedaById", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_busquedas_dto_1.CreateBusquedasDto]),
    __metadata("design:returntype", void 0)
], BusquedasController.prototype, "createBusqueda", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_busquedas_dto_1.UpdateBusquedasDto]),
    __metadata("design:returntype", void 0)
], BusquedasController.prototype, "updateBusqueda", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BusquedasController.prototype, "deleteBusqueda", null);
exports.BusquedasController = BusquedasController = __decorate([
    (0, common_1.Controller)('busquedas'),
    __metadata("design:paramtypes", [busquedas_service_1.BusquedasService])
], BusquedasController);
//# sourceMappingURL=busquedas.controller.js.map