import { HttpException, HttpStatus } from '@nestjs/common';
import { Departamento } from './departamento.entity';
import { Pais } from '../pais/pais.entity';
import { Repository } from 'typeorm';
import { CreateDepartamentoDto } from './dto/create-departamento.dto';
import { UpdateDepartamentoDto } from './dto/update-departamento.dto';
export declare class DepartamentoService {
    private departamentoRepository;
    private paisRepository;
    constructor(departamentoRepository: Repository<Departamento>, paisRepository: Repository<Pais>);
    getDataAll(): Promise<HttpException | {
        created_at: string;
        updated_at: string;
        provincia: {
            created_at: string;
            updated_at: string;
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            departamento_id: number;
            departamento: Departamento;
            distrito: import("../distrito/distrito.entity").Distrito[];
        }[];
        id: number;
        codigo: string;
        nombre: string;
        deleted_at: Date;
        pais_id: number;
        pais: Pais;
    }[]>;
    getData(page?: number, limit?: number): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            provincia: {
                created_at: string;
                updated_at: string;
                id: number;
                codigo: string;
                nombre: string;
                deleted_at: Date;
                departamento_id: number;
                departamento: Departamento;
                distrito: import("../distrito/distrito.entity").Distrito[];
            }[];
            pais: {
                created_at: string;
                updated_at: string;
                id: number;
                nombre: string;
                codigo_telefono: string;
                deleted_at: Date;
                departamento: Departamento[];
            };
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            pais_id: number;
        }[];
        meta: {
            total: number;
            page: number;
            limit: number;
            totalPages: number;
        };
    }>;
    searchData(page: number, limit: number, params: any): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            provincia: {
                created_at: string;
                updated_at: string;
                id: number;
                codigo: string;
                nombre: string;
                deleted_at: Date;
                departamento_id: number;
                departamento: Departamento;
                distrito: import("../distrito/distrito.entity").Distrito[];
            }[];
            pais: {
                created_at: string;
                updated_at: string;
                id: number;
                nombre: string;
                codigo_telefono: string;
                deleted_at: Date;
                departamento: Departamento[];
            };
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            pais_id: number;
        }[];
        meta: {
            total: number;
            page: number;
            limit: number;
            totalPages: number;
        };
    }>;
    getDataById(id: number): Promise<HttpException | {
        created_at: string;
        updated_at: string;
        provincia: {
            created_at: string;
            updated_at: string;
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            departamento_id: number;
            departamento: Departamento;
            distrito: import("../distrito/distrito.entity").Distrito[];
        }[];
        id: number;
        codigo: string;
        nombre: string;
        deleted_at: Date;
        pais_id: number;
        pais: Pais;
    }>;
    createData(departamento: CreateDepartamentoDto): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            provincia: {
                created_at: string;
                updated_at: string;
                id: number;
                codigo: string;
                nombre: string;
                deleted_at: Date;
                departamento_id: number;
                departamento: Departamento;
                distrito: import("../distrito/distrito.entity").Distrito[];
            }[];
            pais: {
                created_at: string;
                updated_at: string;
                id: number;
                nombre: string;
                codigo_telefono: string;
                deleted_at: Date;
                departamento: Departamento[];
            };
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            pais_id: number;
        };
        status: HttpStatus;
        message: string;
    }>;
    updateData(id: number, departamento: UpdateDepartamentoDto): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            pais_id: number;
            pais: Pais;
            provincia: import("../provincia/provincia.entity").Provincia[];
        };
        status: HttpStatus;
        message: string;
    }>;
    deleteData(id: number): Promise<HttpException | import("typeorm").UpdateResult>;
}
