"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DistritoController = void 0;
const common_1 = require("@nestjs/common");
const distrito_service_1 = require("./distrito.service");
const create_distrito_dto_1 = require("./dto/create-distrito.dto");
const update_distrito_dto_1 = require("./dto/update-distrito.dto");
const common_2 = require("@nestjs/common");
const auth_guard_1 = require("../auth/auth.guard");
let DistritoController = class DistritoController {
    constructor(distritoService) {
        this.distritoService = distritoService;
    }
    async getDistritoByProvinciaId(provincia_id) {
        try {
            const data = await this.distritoService.getDataByProvinciaId(provincia_id);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener tipo de vista', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getDistritoAll() {
        try {
            const data = await this.distritoService.getDataAll();
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener tipo de vista', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getAutocompleteDistrito(query) {
        if (!query || query.trim() === '') {
            return new common_1.HttpException('El parámetro query es requerido', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.distritoService.getAutocompleteData(query);
            return {
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener distrito', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getDepartamento(page, limit) {
        if (page <= 0 || limit <= 0) {
            throw new common_1.HttpException('Los valores de página y límite deben ser mayores que 0', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.distritoService.getData(page, limit);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener datos', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getUserSearch(page, limit, body) {
        try {
            const { nombre, provincia_id } = body;
            console.log('Parámetros recibidos:', body);
            const data = await this.distritoService.searchData(page, limit, {
                nombre, provincia_id
            });
            return {
                data,
            };
        }
        catch (error) {
            console.error('Error al buscar distrito:', error);
            throw new common_1.HttpException(error.message || 'Ocurrió un error al procesar la solicitud', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    getDistritoById(id) {
        console.log(id);
        console.log(typeof id);
        return this.distritoService.getDataById(id);
    }
    createDistrito(newDistrito) {
        return this.distritoService.createData(newDistrito);
    }
    updateDistrito(id, distrito) {
        return this.distritoService.updateData(id, distrito);
    }
    deleteDistrito(id) {
        return this.distritoService.deleteData(id);
    }
};
exports.DistritoController = DistritoController;
__decorate([
    (0, common_1.Get)('byProvincia/:provincia_id'),
    __param(0, (0, common_1.Param)('provincia_id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], DistritoController.prototype, "getDistritoByProvinciaId", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)('distritoAll'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], DistritoController.prototype, "getDistritoAll", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)('autocomplete/:query'),
    __param(0, (0, common_1.Param)('query')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], DistritoController.prototype, "getAutocompleteDistrito", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], DistritoController.prototype, "getDepartamento", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)('searchDistrito/:page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", Promise)
], DistritoController.prototype, "getUserSearch", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DistritoController.prototype, "getDistritoById", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_distrito_dto_1.CreateDistritoDto]),
    __metadata("design:returntype", void 0)
], DistritoController.prototype, "createDistrito", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_distrito_dto_1.UpdateDistritoDto]),
    __metadata("design:returntype", void 0)
], DistritoController.prototype, "updateDistrito", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DistritoController.prototype, "deleteDistrito", null);
exports.DistritoController = DistritoController = __decorate([
    (0, common_1.Controller)('distrito'),
    __metadata("design:paramtypes", [distrito_service_1.DistritoService])
], DistritoController);
//# sourceMappingURL=distrito.controller.js.map