import { HttpException, HttpStatus } from '@nestjs/common';
import { Distrito } from './distrito.entity';
import { Provincia } from '../provincia/provincia.entity';
import { Repository } from 'typeorm';
import { CreateDistritoDto } from './dto/create-distrito.dto';
import { UpdateDistritoDto } from './dto/update-distrito.dto';
export declare class DistritoService {
    private distritoRepository;
    private provinciaRepository;
    constructor(distritoRepository: Repository<Distrito>, provinciaRepository: Repository<Provincia>);
    getDataAll(): Promise<HttpException | {
        created_at: string;
        updated_at: string;
        id: number;
        codigo: string;
        nombre: string;
        deleted_at: Date;
        provincia_id: number;
        provincia: Provincia;
        inmueble: import("../inmueble/inmueble.entity").Inmueble[];
    }[]>;
    getAutocompleteData(query: string): Promise<any>;
    getData(page?: number, limit?: number): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            provincia: {
                created_at: string;
                updated_at: string;
                id: number;
                codigo: string;
                nombre: string;
                deleted_at: Date;
                departamento_id: number;
                departamento: import("../departamento/departamento.entity").Departamento;
                distrito: Distrito[];
            };
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            provincia_id: number;
            inmueble: import("../inmueble/inmueble.entity").Inmueble[];
        }[];
        meta: {
            total: number;
            page: number;
            limit: number;
            totalPages: number;
        };
    }>;
    searchData(page: number, limit: number, params: any): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            provincia: {
                created_at: string;
                updated_at: string;
                id: number;
                codigo: string;
                nombre: string;
                deleted_at: Date;
                departamento_id: number;
                departamento: import("../departamento/departamento.entity").Departamento;
                distrito: Distrito[];
            };
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            provincia_id: number;
            inmueble: import("../inmueble/inmueble.entity").Inmueble[];
        }[];
        meta: {
            total: number;
            page: number;
            limit: number;
            totalPages: number;
        };
    }>;
    getDataById(id: number): Promise<HttpException | {
        created_at: string;
        updated_at: string;
        id: number;
        codigo: string;
        nombre: string;
        deleted_at: Date;
        provincia_id: number;
        provincia: Provincia;
        inmueble: import("../inmueble/inmueble.entity").Inmueble[];
    }>;
    getDataByProvinciaId(provincia_id: number): Promise<HttpException | {
        created_at: string;
        updated_at: string;
        id: number;
        codigo: string;
        nombre: string;
        deleted_at: Date;
        provincia_id: number;
        provincia: Provincia;
        inmueble: import("../inmueble/inmueble.entity").Inmueble[];
    }[]>;
    createData(distrito: CreateDistritoDto): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            provincia: {
                created_at: string;
                updated_at: string;
                id: number;
                codigo: string;
                nombre: string;
                deleted_at: Date;
                departamento_id: number;
                departamento: import("../departamento/departamento.entity").Departamento;
                distrito: Distrito[];
            };
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            provincia_id: number;
            inmueble: import("../inmueble/inmueble.entity").Inmueble[];
            departamento_id: number;
            departamento: import("../departamento/departamento.entity").Departamento;
            distrito: Distrito[];
        };
        status: HttpStatus;
        message: string;
    }>;
    updateData(id: number, distrito: UpdateDistritoDto): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            id: number;
            codigo: string;
            nombre: string;
            deleted_at: Date;
            provincia_id: number;
            provincia: Provincia;
            inmueble: import("../inmueble/inmueble.entity").Inmueble[];
        };
        status: HttpStatus;
        message: string;
    }>;
    deleteData(id: number): Promise<HttpException | import("typeorm").UpdateResult>;
}
