"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EstadoInmuebleController = void 0;
const common_1 = require("@nestjs/common");
const estado_inmueble_service_1 = require("./estado-inmueble.service");
const create_estado_inmueble_dto_1 = require("./dto/create-estado-inmueble.dto");
const update_estado_inmueble_dto_1 = require("./dto/update-estado-inmueble.dto");
let EstadoInmuebleController = class EstadoInmuebleController {
    constructor(estadoInmuebleService) {
        this.estadoInmuebleService = estadoInmuebleService;
    }
    async getEstadoInmuebleAll() {
        try {
            const data = await this.estadoInmuebleService.getDataAll();
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener tipo de vista', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getEstadoInmueble(page, limit) {
        if (page <= 0 || limit <= 0) {
            throw new common_1.HttpException('Los valores de página y límite deben ser mayores que 0', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.estadoInmuebleService.getData(page, limit);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener datos', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getUserSearch(page, limit, body) {
        try {
            const { nombre } = body;
            console.log('Parámetros recibidos:', body);
            const data = await this.estadoInmuebleService.searchData(page, limit, {
                nombre
            });
            return {
                data,
            };
        }
        catch (error) {
            console.error('Error al buscar tipo operacion:', error);
            throw new common_1.HttpException(error.message || 'Ocurrió un error al procesar la solicitud', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    getEstadoInmuebleById(id) {
        console.log(id);
        console.log(typeof id);
        return this.estadoInmuebleService.getDataById(id);
    }
    createEstadoInmueble(newEstadoInmueble) {
        return this.estadoInmuebleService.createData(newEstadoInmueble);
    }
    updateEstadoInmueble(id, estadoInmueble) {
        return this.estadoInmuebleService.updateData(id, estadoInmueble);
    }
    deleteEstadoInmueble(id) {
        return this.estadoInmuebleService.deleteData(id);
    }
};
exports.EstadoInmuebleController = EstadoInmuebleController;
__decorate([
    (0, common_1.Get)('estadoInmuebleAll'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], EstadoInmuebleController.prototype, "getEstadoInmuebleAll", null);
__decorate([
    (0, common_1.Get)(':page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], EstadoInmuebleController.prototype, "getEstadoInmueble", null);
__decorate([
    (0, common_1.Post)('searchEstadoInmueble/:page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", Promise)
], EstadoInmuebleController.prototype, "getUserSearch", null);
__decorate([
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], EstadoInmuebleController.prototype, "getEstadoInmuebleById", null);
__decorate([
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_estado_inmueble_dto_1.CreateEstadoInmuebleDto]),
    __metadata("design:returntype", void 0)
], EstadoInmuebleController.prototype, "createEstadoInmueble", null);
__decorate([
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_estado_inmueble_dto_1.UpdateEstadoInmuebleDto]),
    __metadata("design:returntype", void 0)
], EstadoInmuebleController.prototype, "updateEstadoInmueble", null);
__decorate([
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], EstadoInmuebleController.prototype, "deleteEstadoInmueble", null);
exports.EstadoInmuebleController = EstadoInmuebleController = __decorate([
    (0, common_1.Controller)('estado-inmueble'),
    __metadata("design:paramtypes", [estado_inmueble_service_1.EstadoInmuebleService])
], EstadoInmuebleController);
//# sourceMappingURL=estado-inmueble.controller.js.map