"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EstadoInmuebleService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const estado_inmueble_entity_1 = require("./estado-inmueble.entity");
const typeorm_2 = require("typeorm");
const date_fns_1 = require("date-fns");
let EstadoInmuebleService = class EstadoInmuebleService {
    constructor(estadoInmuebleRepository) {
        this.estadoInmuebleRepository = estadoInmuebleRepository;
    }
    async getDataAll() {
        const estadoInmueble = await this.estadoInmuebleRepository.createQueryBuilder('estado_inmueble')
            .andWhere('estado_inmueble.deleted_at IS NULL')
            .getMany();
        if (!estadoInmueble.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return estadoInmueble.map(estadoInmueble => ({
                ...estadoInmueble,
                created_at: (0, date_fns_1.format)(estadoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(estadoInmueble.updated_at, 'dd/MM/yyyy'),
            }));
        }
    }
    async getData(page = 1, limit = 2) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const [data, total] = await this.estadoInmuebleRepository.createQueryBuilder('estado_inmueble')
            .andWhere('estado_inmueble.deleted_at IS NULL')
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(estadoInmueble => ({
                ...estadoInmueble,
                created_at: (0, date_fns_1.format)(estadoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(estadoInmueble.updated_at, 'dd/MM/yyyy'),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async searchData(page = 1, limit = 9, params) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const query = this.estadoInmuebleRepository.createQueryBuilder('estado_inmueble')
            .andWhere('estado_inmueble.deleted_at IS NULL');
        if (params.nombre) {
            console.log('params:');
            console.log(params);
            query.andWhere('estado_inmueble.nombre LIKE :nombre', { nombre: `%${params.nombre}%` });
        }
        const [data, total] = await query
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        console.log('data:');
        console.log(data);
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(estadoInmueble => ({
                ...estadoInmueble,
                created_at: (0, date_fns_1.format)(estadoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(estadoInmueble.updated_at, 'dd/MM/yyyy'),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async getDataById(id) {
        const estadoInmueble = await this.estadoInmuebleRepository.createQueryBuilder('estado_inmueble')
            .andWhere('estado_inmueble.deleted_at IS NULL')
            .where('estado_inmueble.id = :id', { id })
            .getOne();
        if (!estadoInmueble) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return {
                ...estadoInmueble,
                created_at: (0, date_fns_1.format)(estadoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(estadoInmueble.updated_at, 'dd/MM/yyyy'),
            };
        }
    }
    async createData(estadoInmueble) {
        const estadoInmuebleFound = await this.estadoInmuebleRepository.findOne({
            where: {
                nombre: estadoInmueble.nombre,
                deleted_at: null
            }
        });
        if (estadoInmuebleFound) {
            return new common_1.HttpException({
                status: common_1.HttpStatus.CONFLICT,
                message: 'Estado inmueble ya existe',
            }, common_1.HttpStatus.CONFLICT);
        }
        else {
            const newEstadoInmueble = this.estadoInmuebleRepository.create(estadoInmueble);
            const savedEstadoInmueble = await this.estadoInmuebleRepository.save(newEstadoInmueble);
            const formattedData = {
                ...savedEstadoInmueble,
                created_at: (0, date_fns_1.format)(savedEstadoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(savedEstadoInmueble.updated_at, 'dd/MM/yyyy')
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Estado inmueble creada exitosamente',
            };
        }
    }
    async updateData(id, estadoInmueble) {
        const estadoInmuebleFound = await this.estadoInmuebleRepository.findOne({
            where: {
                id: id
            }
        });
        if (!estadoInmuebleFound) {
            return new common_1.HttpException('Estado inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const { created_at } = estadoInmuebleFound;
            const updateEstadoInmueble = Object.assign(estadoInmuebleFound, estadoInmueble);
            updateEstadoInmueble.updated_at = new Date();
            updateEstadoInmueble.created_at = created_at;
            const data = await this.estadoInmuebleRepository.save(updateEstadoInmueble);
            const formattedData = {
                ...data,
                created_at: (0, date_fns_1.format)(new Date(data.created_at), 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(new Date(data.updated_at), 'dd/MM/yyyy')
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Estado inmueble actualizado exitosamente',
            };
        }
    }
    async deleteData(id) {
        const rs = await this.estadoInmuebleRepository.createQueryBuilder()
            .update(estado_inmueble_entity_1.EstadoInmueble)
            .set({ deleted_at: () => 'CURRENT_TIMESTAMP' })
            .where('id = :id', { id })
            .execute();
        if (rs.affected === 0) {
            console.log(rs.affected);
            return new common_1.HttpException('Estado inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return rs;
        }
    }
};
exports.EstadoInmuebleService = EstadoInmuebleService;
exports.EstadoInmuebleService = EstadoInmuebleService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(estado_inmueble_entity_1.EstadoInmueble)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], EstadoInmuebleService);
//# sourceMappingURL=estado-inmueble.service.js.map