"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GaleriaController = void 0;
const common_1 = require("@nestjs/common");
const create_galeria_dto_1 = require("./dto/create-galeria.dto");
const galeria_service_1 = require("./galeria.service");
const update_galeria_dto_1 = require("./dto/update-galeria.dto");
const platform_express_1 = require("@nestjs/platform-express");
const fileValidator_1 = require("../pipes/fileValidator");
let GaleriaController = class GaleriaController {
    constructor(galeriaService) {
        this.galeriaService = galeriaService;
    }
    getGaleria() {
        return this.galeriaService.getData();
    }
    getGaleriaById(id) {
        console.log(id);
        console.log(typeof id);
        return this.galeriaService.getDataById(id);
    }
    getGaleriaByInmueble(id) {
        console.log(id);
        console.log(typeof id);
        return this.galeriaService.getDataByInmueble(id);
    }
    async createGaleriaImage(files, newGaleria) {
        this.pathImage = '/imageUser';
        const fileDesktop = files.fileImageGaleriaDesktop?.[0];
        const fileMobile = files.fileImageGaleriaMobile?.[0];
        if (fileDesktop && fileMobile) {
            newGaleria.url_desktop = fileDesktop.filename;
            newGaleria.url_mobile = fileMobile.filename;
            return await this.galeriaService.createData(newGaleria);
        }
        else {
            throw new common_1.HttpException('Ambos archivos son obligatorios', common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async saveGaleriaImage(files, newGaleria) {
        this.pathImage = '/imageUser';
        const fileDesktop = files.fileImageGaleriaDesktop?.[0];
        if (fileDesktop) {
            newGaleria.url_desktop = fileDesktop.filename;
            return {
                data: newGaleria,
                status: common_1.HttpStatus.OK,
                message: 'Imagen Guardada exitosamente',
            };
        }
        else {
            throw new common_1.HttpException('Archivos obligatorio', common_1.HttpStatus.BAD_REQUEST);
        }
    }
    updateUserImage(id, fileDesktop, fileMobile, galeria) {
        this.pathImage = '/imageUser';
        console.log(fileDesktop);
        if (fileDesktop.filename && fileMobile.filename) {
            galeria.url_desktop = fileDesktop.filename;
            galeria.url_mobile = fileMobile.filename;
            console.log(id);
            console.log(typeof id);
            return this.galeriaService.updateData(id, galeria);
        }
        else {
            console.log('file 2');
            return fileDesktop;
        }
    }
    deleteUser(id) {
        return this.galeriaService.deleteData(id);
    }
};
exports.GaleriaController = GaleriaController;
__decorate([
    (0, common_1.Get)(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], GaleriaController.prototype, "getGaleria", null);
__decorate([
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], GaleriaController.prototype, "getGaleriaById", null);
__decorate([
    (0, common_1.Get)('galeriaByInmueble/:inmueble_id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], GaleriaController.prototype, "getGaleriaByInmueble", null);
__decorate([
    (0, common_1.Post)('uploadGaleriaImage'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileFieldsInterceptor)([
        { name: 'fileImageGaleriaDesktop', maxCount: 1 },
        { name: 'fileImageGaleriaMobile', maxCount: 1 },
    ])),
    __param(0, (0, common_1.UploadedFiles)()),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_galeria_dto_1.CreateGaleriaDto]),
    __metadata("design:returntype", Promise)
], GaleriaController.prototype, "createGaleriaImage", null);
__decorate([
    (0, common_1.Post)('uploadSaveImage'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileFieldsInterceptor)([
        { name: 'fileImageGaleriaDesktop', maxCount: 1 },
    ])),
    __param(0, (0, common_1.UploadedFiles)()),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_galeria_dto_1.CreateGaleriaDto]),
    __metadata("design:returntype", Promise)
], GaleriaController.prototype, "saveGaleriaImage", null);
__decorate([
    (0, common_1.Patch)(':id'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('fileImageGaleriaDesktop')),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('fileImageGaleriaMobile')),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.UploadedFile)(fileValidator_1.FileValidationPipe)),
    __param(3, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object, Object, update_galeria_dto_1.UpdateGaleriaDto]),
    __metadata("design:returntype", void 0)
], GaleriaController.prototype, "updateUserImage", null);
__decorate([
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], GaleriaController.prototype, "deleteUser", null);
exports.GaleriaController = GaleriaController = __decorate([
    (0, common_1.Controller)('galeria'),
    __metadata("design:paramtypes", [galeria_service_1.GaleriaService])
], GaleriaController);
//# sourceMappingURL=galeria.controller.js.map