"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GaleriaModule = void 0;
const common_1 = require("@nestjs/common");
const galeria_controller_1 = require("./galeria.controller");
const galeria_service_1 = require("./galeria.service");
const typeorm_1 = require("@nestjs/typeorm");
const galeria_entity_1 = require("./galeria.entity");
const platform_express_1 = require("@nestjs/platform-express");
const multer_1 = require("multer");
const uuid_1 = require("uuid");
const path = require("path");
const fs = require("fs");
let GaleriaModule = class GaleriaModule {
};
exports.GaleriaModule = GaleriaModule;
exports.GaleriaModule = GaleriaModule = __decorate([
    (0, common_1.Module)({
        imports: [
            typeorm_1.TypeOrmModule.forFeature([galeria_entity_1.Galeria]),
            platform_express_1.MulterModule.registerAsync({
                useFactory: () => ({
                    storage: (0, multer_1.diskStorage)({
                        destination: (req, file, cb) => {
                            const uploadPath = path.join('upload', file.fieldname);
                            fs.mkdirSync(uploadPath, { recursive: true });
                            cb(null, uploadPath);
                        },
                        filename: (req, file, cb) => {
                            const ext = path.extname(file.originalname);
                            const filename = `${(0, uuid_1.v4)()}${ext}`;
                            cb(null, filename);
                        },
                    }),
                }),
            })
        ],
        controllers: [galeria_controller_1.GaleriaController],
        providers: [galeria_service_1.GaleriaService],
        exports: [galeria_service_1.GaleriaService]
    })
], GaleriaModule);
//# sourceMappingURL=galeria.module.js.map