import { HttpException, HttpStatus } from '@nestjs/common';
import { InmuebleAreasSociales } from './inmueble-areas-sociales.entity';
import { Repository } from 'typeorm';
import { CreateInmuebleAreasSocialesDto } from './dto/create-inmueble-areas-sociales.dto';
import { UpdateInmuebleAreasSocialesDto } from './dto/update-inmueble-areas-sociales.dto';
export declare class InmuebleAreasSocialesService {
    private inmuebleAreasSocialesRepository;
    constructor(inmuebleAreasSocialesRepository: Repository<InmuebleAreasSociales>);
    createData(inmuebleAreasSociales: CreateInmuebleAreasSocialesDto): Promise<HttpException | {
        data: Promise<({
            inmueble_id: number;
            areas_sociales_id: number;
        } & InmuebleAreasSociales)[]>;
        id: number;
        status: HttpStatus;
        message: string;
    }>;
    getData(): Promise<HttpException | {
        created_at: string;
        updated_at: string;
        inmueble: {
            created_at: string;
            updated_at: string;
            id: number;
            bathroom: number;
            dormitorios: number;
            cocheras: number;
            ambientes: number;
            mascotas: string;
            cuarto_servicio: string;
            balcon: string;
            terraza: string;
            ascensor: string;
            condominio: string;
            deposito: string;
            proyecto: string;
            areas_sociales: string;
            area: number;
            area_techada: number;
            precio: string;
            precio_mantenimiento: string;
            piso: number;
            descripcion: string;
            direccion: string;
            latitud: string;
            longitud: string;
            zoom: string;
            antiguedad: number;
            estreno: string;
            titulo: string;
            tipo_vivienda_id: number;
            tipo_operacion_id: number;
            tipo_inmueble_id: number;
            nivel_amoblado_id: number;
            distrito_id: number;
            user_id: number;
            tipo_ubicacion_id: number;
            estado_inmueble_id: number;
            deleted_at: Date;
            tipo_moneda_id: number;
            estado_id: number;
            tipoMoneda: import("../tipo-moneda/tipo-moneda.entity").TipoMoneda;
            tipoVivienda: import("../tipo-vivienda/tipo-vivienda.entity").TipoVivienda;
            tipoOperacion: import("../tipo-operacion/tipo-operacion.entity").TipoOperacion;
            estado: import("../estado/estado.entity").Estado;
            estadoInmueble: import("../estado-inmueble/estado-inmueble.entity").EstadoInmueble;
            tipoInmueble: import("../tipo-inmueble/tipo-inmueble.entity").TipoInmueble;
            nivelAmoblado: import("../nivel-amoblado/nivel-amoblado.entity").NivelAmoblado;
            distrito: import("../distrito/distrito.entity").Distrito;
            user: import("../users/user.entity").User;
            tipoUbicacion: import("../tipo-ubicacion/tipo-ubicacion.entity").TipoUbicacion;
            favoritos: import("../favoritos/favoritos.entity").Favoritos[];
            inmuebleAreasSociales: InmuebleAreasSociales[];
            galeria: import("../galeria/galeria.entity").Galeria[];
            inmuebleEstados: import("../inmueble-estados/inmueble-estados.entity").InmuebleEstados[];
            inmuebleVistas: import("../inmueble-vistas/inmueble-vistas.entity").InmuebleVistas[];
        };
        areasSociales: {
            created_at: string;
            updated_at: string;
            id: number;
            nombre: string;
            icono_svg: string;
            deleted_at: Date;
            inmuebleAreasSociales: InmuebleAreasSociales[];
        };
        id: number;
        deleted_at: Date;
        inmueble_id: number;
        areas_sociales_id: number;
    }[]>;
    getDataById(id: number): Promise<HttpException | {
        created_at: string;
        updated_at: string;
        inmueble: {
            created_at: string;
            updated_at: string;
            id: number;
            bathroom: number;
            dormitorios: number;
            cocheras: number;
            ambientes: number;
            mascotas: string;
            cuarto_servicio: string;
            balcon: string;
            terraza: string;
            ascensor: string;
            condominio: string;
            deposito: string;
            proyecto: string;
            areas_sociales: string;
            area: number;
            area_techada: number;
            precio: string;
            precio_mantenimiento: string;
            piso: number;
            descripcion: string;
            direccion: string;
            latitud: string;
            longitud: string;
            zoom: string;
            antiguedad: number;
            estreno: string;
            titulo: string;
            tipo_vivienda_id: number;
            tipo_operacion_id: number;
            tipo_inmueble_id: number;
            nivel_amoblado_id: number;
            distrito_id: number;
            user_id: number;
            tipo_ubicacion_id: number;
            estado_inmueble_id: number;
            deleted_at: Date;
            tipo_moneda_id: number;
            estado_id: number;
            tipoMoneda: import("../tipo-moneda/tipo-moneda.entity").TipoMoneda;
            tipoVivienda: import("../tipo-vivienda/tipo-vivienda.entity").TipoVivienda;
            tipoOperacion: import("../tipo-operacion/tipo-operacion.entity").TipoOperacion;
            estado: import("../estado/estado.entity").Estado;
            estadoInmueble: import("../estado-inmueble/estado-inmueble.entity").EstadoInmueble;
            tipoInmueble: import("../tipo-inmueble/tipo-inmueble.entity").TipoInmueble;
            nivelAmoblado: import("../nivel-amoblado/nivel-amoblado.entity").NivelAmoblado;
            distrito: import("../distrito/distrito.entity").Distrito;
            user: import("../users/user.entity").User;
            tipoUbicacion: import("../tipo-ubicacion/tipo-ubicacion.entity").TipoUbicacion;
            favoritos: import("../favoritos/favoritos.entity").Favoritos[];
            inmuebleAreasSociales: InmuebleAreasSociales[];
            galeria: import("../galeria/galeria.entity").Galeria[];
            inmuebleEstados: import("../inmueble-estados/inmueble-estados.entity").InmuebleEstados[];
            inmuebleVistas: import("../inmueble-vistas/inmueble-vistas.entity").InmuebleVistas[];
        };
        user: {
            created_at: string;
            updated_at: string;
            id: number;
            nombre: string;
            icono_svg: string;
            deleted_at: Date;
            inmuebleAreasSociales: InmuebleAreasSociales[];
        };
        id: number;
        deleted_at: Date;
        inmueble_id: number;
        areas_sociales_id: number;
        areasSociales: import("../areas-sociales/areas-sociales.entity").AreasSociales;
    }>;
    updateData(id: number, inmuebleAreasSociales: UpdateInmuebleAreasSocialesDto): Promise<HttpException | (InmuebleAreasSociales & UpdateInmuebleAreasSocialesDto)>;
    deleteData(id: number): Promise<HttpException | import("typeorm").UpdateResult>;
}
