"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InmuebleService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const inmueble_entity_1 = require("./inmueble.entity");
const vista_entity_1 = require("../vista/vista.entity");
const tipo_vivienda_entity_1 = require("../tipo-vivienda/tipo-vivienda.entity");
const estado_proyecto_entity_1 = require("../estado-proyecto/estado-proyecto.entity");
const tipo_operacion_entity_1 = require("../tipo-operacion/tipo-operacion.entity");
const estado_inmueble_entity_1 = require("../estado-inmueble/estado-inmueble.entity");
const tipo_inmueble_entity_1 = require("../tipo-inmueble/tipo-inmueble.entity");
const nivel_amoblado_entity_1 = require("../nivel-amoblado/nivel-amoblado.entity");
const distrito_entity_1 = require("../distrito/distrito.entity");
const user_entity_1 = require("../users/user.entity");
const tipo_ubicacion_entity_1 = require("../tipo-ubicacion/tipo-ubicacion.entity");
const tipo_moneda_entity_1 = require("../tipo-moneda/tipo-moneda.entity");
const estado_entity_1 = require("../estado/estado.entity");
const galeria_entity_1 = require("../galeria/galeria.entity");
const inmueble_areas_sociales_entity_1 = require("../inmueble-areas-sociales/inmueble-areas-sociales.entity");
const inmueble_estados_entity_1 = require("../inmueble-estados/inmueble-estados.entity");
const inmueble_vistas_entity_1 = require("../inmueble-vistas/inmueble-vistas.entity");
const typeorm_2 = require("typeorm");
const date_fns_1 = require("date-fns");
let InmuebleService = class InmuebleService {
    constructor(inmuebleRepository, dataSource, vistaRepository, tipoViviendaRepository, estadoProyectoRepository, tipoOperacionRepository, estadoInmuebleRepository, tipoInmuebleRepository, nivelAmobladoRepository, distritoRepository, userRepository, tipoUbicacionRepository, tipoMonedaRepository, estadoRepository, galeriaRepository, inmuebleAreasSocialesRepository, inmuebleEstadosRepository, inmuebleVistasRepository) {
        this.inmuebleRepository = inmuebleRepository;
        this.dataSource = dataSource;
        this.vistaRepository = vistaRepository;
        this.tipoViviendaRepository = tipoViviendaRepository;
        this.estadoProyectoRepository = estadoProyectoRepository;
        this.tipoOperacionRepository = tipoOperacionRepository;
        this.estadoInmuebleRepository = estadoInmuebleRepository;
        this.tipoInmuebleRepository = tipoInmuebleRepository;
        this.nivelAmobladoRepository = nivelAmobladoRepository;
        this.distritoRepository = distritoRepository;
        this.userRepository = userRepository;
        this.tipoUbicacionRepository = tipoUbicacionRepository;
        this.tipoMonedaRepository = tipoMonedaRepository;
        this.estadoRepository = estadoRepository;
        this.galeriaRepository = galeriaRepository;
        this.inmuebleAreasSocialesRepository = inmuebleAreasSocialesRepository;
        this.inmuebleEstadosRepository = inmuebleEstadosRepository;
        this.inmuebleVistasRepository = inmuebleVistasRepository;
    }
    async getDataAll() {
        const data = await this.inmuebleRepository.createQueryBuilder('inmueble')
            .leftJoinAndSelect('inmueble.tipoVivienda', 'tipoVivienda', 'tipoVivienda.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoOperacion', 'tipoOperacion', 'tipoOperacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.estadoInmueble', 'estadoInmueble', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.tipoInmueble', 'tipoInmueble', 'tipoInmueble.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.nivelAmoblado', 'nivelAmoblado', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.distrito', 'distrito', 'distrito.deleted_at IS NULL')
            .leftJoinAndSelect('distrito.provincia', 'provincia')
            .leftJoinAndSelect('provincia.departamento', 'departamento')
            .leftJoinAndSelect('departamento.pais', 'pais')
            .innerJoinAndSelect('inmueble.user', 'user', 'user.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoUbicacion', 'tipoUbicacion', 'tipoUbicacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.galeria', 'galeria', 'galeria.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleAreasSociales', 'inmuebleAreasSociales', 'inmuebleAreasSociales.deleted_at IS NULL')
            .leftJoinAndSelect('inmuebleAreasSociales.areasSociales', 'areasSociales', 'areasSociales.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleVistas', 'inmuebleVistas')
            .leftJoinAndSelect('inmuebleVistas.vista', 'vista', 'vista.deleted_at IS NULL')
            .leftJoinAndSelect('vista.tipoVista', 'tipoVista', 'tipoVista.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleEstados', 'inmuebleEstados')
            .leftJoinAndSelect('inmuebleEstados.estadoProyecto', 'estadoProyecto')
            .leftJoinAndSelect('inmueble.estado', 'estado')
            .innerJoinAndSelect('inmueble.tipoMoneda', 'tipoMoneda', 'tipoMoneda.deleted_at IS NULL')
            .where('inmueble.deleted_at IS NULL')
            .where('tipoVivienda.deleted_at IS NULL')
            .where('tipoOperacion.deleted_at IS NULL')
            .where('estadoInmueble.deleted_at IS NULL')
            .where('tipoInmueble.deleted_at IS NULL')
            .where('nivelAmoblado.deleted_at IS NULL')
            .where('distrito.deleted_at IS NULL')
            .where('provincia.deleted_at IS NULL')
            .where('departamento.deleted_at IS NULL')
            .where('pais.deleted_at IS NULL')
            .where('user.deleted_at IS NULL')
            .where('tipoUbicacion.deleted_at IS NULL')
            .where('galeria.deleted_at IS NULL')
            .where('inmuebleAreasSociales.deleted_at IS NULL')
            .where('areasSociales.deleted_at IS NULL')
            .where('inmuebleVistas.deleted_at IS NULL')
            .where('vista.deleted_at IS NULL')
            .where('tipoVista.deleted_at IS NULL')
            .where('inmuebleEstados.deleted_at IS NULL')
            .where('estadoProyecto.deleted_at IS NULL')
            .where('tipoMoneda.deleted_at IS NULL')
            .orderBy('inmueble.id', 'DESC')
            .getMany();
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return data.map(inmueble => ({
                ...inmueble,
                created_at: (0, date_fns_1.format)(inmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(inmueble.updated_at, 'dd/MM/yyyy'),
                tipoInmueble: inmueble.tipoInmueble ? {
                    ...inmueble.tipoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoOperacion: inmueble.tipoOperacion ? {
                    ...inmueble.tipoOperacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                estadoInmueble: inmueble.estadoInmueble ? {
                    ...inmueble.estadoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                nivelAmoblado: inmueble.nivelAmoblado ? {
                    ...inmueble.nivelAmoblado,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.updated_at), 'dd/MM/yyyy'),
                } : null,
                distrito: inmueble.distrito ? {
                    ...inmueble.distrito,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.updated_at), 'dd/MM/yyyy'),
                    provincia: {
                        ...inmueble.distrito.provincia,
                        created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.created_at), 'dd/MM/yyyy'),
                        updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.updated_at), 'dd/MM/yyyy'),
                        departamento: {
                            ...inmueble.distrito.provincia.departamento,
                            created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.created_at), 'dd/MM/yyyy'),
                            updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.updated_at), 'dd/MM/yyyy'),
                        },
                    },
                } : null,
                user: inmueble.user ? {
                    ...inmueble.user,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.user.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.user.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoUbicacion: inmueble.tipoUbicacion ? {
                    ...inmueble.tipoUbicacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                galeria: inmueble.galeria.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
                inmuebleAreasSociales: inmueble.inmuebleAreasSociales
                    ? inmueble.inmuebleAreasSociales.map(as => ({
                        ...as,
                        created_at: as?.created_at ? (0, date_fns_1.format)(new Date(as.created_at), 'dd/MM/yyyy') : null,
                        updated_at: as?.updated_at ? (0, date_fns_1.format)(new Date(as.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                inmuebleVistas: inmueble.inmuebleVistas
                    ? inmueble.inmuebleVistas.map(vi => ({
                        ...vi,
                        created_at: vi?.created_at ? (0, date_fns_1.format)(new Date(vi.created_at), 'dd/MM/yyyy') : null,
                        updated_at: vi?.updated_at ? (0, date_fns_1.format)(new Date(vi.updated_at), 'dd/MM/yyyy') : null,
                        vista: vi.vista
                            ? {
                                ...vi.vista,
                                created_at: vi.vista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.created_at), 'dd/MM/yyyy') : null,
                                updated_at: vi.vista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.updated_at), 'dd/MM/yyyy') : null,
                                tipoVista: vi.vista.tipoVista
                                    ? {
                                        ...vi.vista.tipoVista,
                                        created_at: vi.vista.tipoVista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.created_at), 'dd/MM/yyyy') : null,
                                        updated_at: vi.vista.tipoVista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.updated_at), 'dd/MM/yyyy') : null,
                                    }
                                    : null,
                            }
                            : null,
                    }))
                    : [],
                inmuebleEstados: inmueble.inmuebleEstados
                    ? inmueble.inmuebleEstados.map(es => ({
                        ...es,
                        created_at: es?.created_at ? (0, date_fns_1.format)(new Date(es.created_at), 'dd/MM/yyyy') : null,
                        updated_at: es?.updated_at ? (0, date_fns_1.format)(new Date(es.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                uniqueTipoVistas: Array.from(new Set(inmueble.inmuebleVistas
                    ?.map(vi => vi.vista?.tipoVista)
                    .filter(tipoVista => tipoVista)
                    .map(tv => JSON.stringify(tv)))).map(str => JSON.parse(str))
            }));
        }
    }
    async getData(page = 1, limit = 10) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 10;
        const offset = (page - 1) * limit;
        const [data, total] = await this.inmuebleRepository.createQueryBuilder('inmueble')
            .leftJoinAndSelect('inmueble.tipoVivienda', 'tipoVivienda', 'tipoVivienda.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoOperacion', 'tipoOperacion', 'tipoOperacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.estadoInmueble', 'estadoInmueble', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.tipoInmueble', 'tipoInmueble', 'tipoInmueble.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.nivelAmoblado', 'nivelAmoblado', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.distrito', 'distrito', 'distrito.deleted_at IS NULL')
            .leftJoinAndSelect('distrito.provincia', 'provincia')
            .leftJoinAndSelect('provincia.departamento', 'departamento')
            .leftJoinAndSelect('departamento.pais', 'pais')
            .innerJoinAndSelect('inmueble.user', 'user', 'user.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoUbicacion', 'tipoUbicacion', 'tipoUbicacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.galeria', 'galeria', 'galeria.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleAreasSociales', 'inmuebleAreasSociales', 'inmuebleAreasSociales.deleted_at IS NULL')
            .leftJoinAndSelect('inmuebleAreasSociales.areasSociales', 'areasSociales', 'areasSociales.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleVistas', 'inmuebleVistas')
            .leftJoinAndSelect('inmuebleVistas.vista', 'vista', 'vista.deleted_at IS NULL')
            .leftJoinAndSelect('vista.tipoVista', 'tipoVista', 'tipoVista.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleEstados', 'inmuebleEstados')
            .leftJoinAndSelect('inmuebleEstados.estadoProyecto', 'estadoProyecto')
            .leftJoinAndSelect('inmueble.estado', 'estado')
            .innerJoinAndSelect('inmueble.tipoMoneda', 'tipoMoneda', 'tipoMoneda.deleted_at IS NULL')
            .where('inmueble.deleted_at IS NULL')
            .where('tipoVivienda.deleted_at IS NULL')
            .where('tipoOperacion.deleted_at IS NULL')
            .where('estadoInmueble.deleted_at IS NULL')
            .where('tipoInmueble.deleted_at IS NULL')
            .where('nivelAmoblado.deleted_at IS NULL')
            .where('distrito.deleted_at IS NULL')
            .where('provincia.deleted_at IS NULL')
            .where('departamento.deleted_at IS NULL')
            .where('pais.deleted_at IS NULL')
            .where('user.deleted_at IS NULL')
            .where('tipoUbicacion.deleted_at IS NULL')
            .where('galeria.deleted_at IS NULL')
            .where('inmuebleAreasSociales.deleted_at IS NULL')
            .where('areasSociales.deleted_at IS NULL')
            .where('inmuebleVistas.deleted_at IS NULL')
            .where('vista.deleted_at IS NULL')
            .where('tipoVista.deleted_at IS NULL')
            .where('inmuebleEstados.deleted_at IS NULL')
            .where('estadoProyecto.deleted_at IS NULL')
            .where('tipoMoneda.deleted_at IS NULL')
            .skip(offset)
            .take(limit)
            .orderBy('inmueble.id', 'DESC')
            .getManyAndCount();
        if (!data.length) {
            throw new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(inmueble => ({
                ...inmueble,
                created_at: (0, date_fns_1.format)(inmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(inmueble.updated_at, 'dd/MM/yyyy'),
                tipoInmueble: inmueble.tipoInmueble ? {
                    ...inmueble.tipoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoOperacion: inmueble.tipoOperacion ? {
                    ...inmueble.tipoOperacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                estadoInmueble: inmueble.estadoInmueble ? {
                    ...inmueble.estadoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                nivelAmoblado: inmueble.nivelAmoblado ? {
                    ...inmueble.nivelAmoblado,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.updated_at), 'dd/MM/yyyy'),
                } : null,
                distrito: inmueble.distrito ? {
                    ...inmueble.distrito,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.updated_at), 'dd/MM/yyyy'),
                    provincia: {
                        ...inmueble.distrito.provincia,
                        created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.created_at), 'dd/MM/yyyy'),
                        updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.updated_at), 'dd/MM/yyyy'),
                        departamento: {
                            ...inmueble.distrito.provincia.departamento,
                            created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.created_at), 'dd/MM/yyyy'),
                            updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.updated_at), 'dd/MM/yyyy'),
                        },
                    },
                } : null,
                user: inmueble.user ? {
                    ...inmueble.user,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.user.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.user.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoUbicacion: inmueble.tipoUbicacion ? {
                    ...inmueble.tipoUbicacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                galeria: inmueble.galeria.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
                inmuebleAreasSociales: inmueble.inmuebleAreasSociales
                    ? inmueble.inmuebleAreasSociales.map(as => ({
                        ...as,
                        created_at: as?.created_at ? (0, date_fns_1.format)(new Date(as.created_at), 'dd/MM/yyyy') : null,
                        updated_at: as?.updated_at ? (0, date_fns_1.format)(new Date(as.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                inmuebleVistas: inmueble.inmuebleVistas
                    ? inmueble.inmuebleVistas.map(vi => ({
                        ...vi,
                        created_at: vi?.created_at ? (0, date_fns_1.format)(new Date(vi.created_at), 'dd/MM/yyyy') : null,
                        updated_at: vi?.updated_at ? (0, date_fns_1.format)(new Date(vi.updated_at), 'dd/MM/yyyy') : null,
                        vista: vi.vista
                            ? {
                                ...vi.vista,
                                created_at: vi.vista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.created_at), 'dd/MM/yyyy') : null,
                                updated_at: vi.vista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.updated_at), 'dd/MM/yyyy') : null,
                                tipoVista: vi.vista.tipoVista
                                    ? {
                                        ...vi.vista.tipoVista,
                                        created_at: vi.vista.tipoVista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.created_at), 'dd/MM/yyyy') : null,
                                        updated_at: vi.vista.tipoVista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.updated_at), 'dd/MM/yyyy') : null,
                                    }
                                    : null,
                            }
                            : null,
                    }))
                    : [],
                inmuebleEstados: inmueble.inmuebleEstados
                    ? inmueble.inmuebleEstados.map(es => ({
                        ...es,
                        created_at: es?.created_at ? (0, date_fns_1.format)(new Date(es.created_at), 'dd/MM/yyyy') : null,
                        updated_at: es?.updated_at ? (0, date_fns_1.format)(new Date(es.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                uniqueTipoVistas: Array.from(new Set(inmueble.inmuebleVistas
                    ?.map(vi => vi.vista?.tipoVista)
                    .filter(tipoVista => tipoVista)
                    .map(tv => JSON.stringify(tv)))).map(str => JSON.parse(str))
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async getDataById(id) {
        const inmueble = await this.inmuebleRepository.createQueryBuilder('inmueble')
            .leftJoinAndSelect('inmueble.tipoVivienda', 'tipoVivienda', 'tipoVivienda.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoOperacion', 'tipoOperacion', 'tipoOperacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.estadoInmueble', 'estadoInmueble', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.tipoInmueble', 'tipoInmueble', 'tipoInmueble.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.nivelAmoblado', 'nivelAmoblado', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.distrito', 'distrito', 'distrito.deleted_at IS NULL')
            .leftJoinAndSelect('distrito.provincia', 'provincia')
            .leftJoinAndSelect('provincia.departamento', 'departamento')
            .leftJoinAndSelect('departamento.pais', 'pais')
            .innerJoinAndSelect('inmueble.user', 'user', 'user.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoUbicacion', 'tipoUbicacion', 'tipoUbicacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.galeria', 'galeria', 'galeria.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleAreasSociales', 'inmuebleAreasSociales', 'inmuebleAreasSociales.deleted_at IS NULL')
            .leftJoinAndSelect('inmuebleAreasSociales.areasSociales', 'areasSociales', 'areasSociales.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleVistas', 'inmuebleVistas')
            .leftJoinAndSelect('inmuebleVistas.vista', 'vista', 'vista.deleted_at IS NULL')
            .leftJoinAndSelect('vista.tipoVista', 'tipoVista', 'tipoVista.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleEstados', 'inmuebleEstados')
            .leftJoinAndSelect('inmuebleEstados.estadoProyecto', 'estadoProyecto')
            .leftJoinAndSelect('inmueble.estado', 'estado')
            .innerJoinAndSelect('inmueble.tipoMoneda', 'tipoMoneda', 'tipoMoneda.deleted_at IS NULL')
            .where('inmueble.deleted_at IS NULL')
            .where('tipoVivienda.deleted_at IS NULL')
            .where('tipoOperacion.deleted_at IS NULL')
            .where('estadoInmueble.deleted_at IS NULL')
            .where('tipoInmueble.deleted_at IS NULL')
            .where('nivelAmoblado.deleted_at IS NULL')
            .where('distrito.deleted_at IS NULL')
            .where('provincia.deleted_at IS NULL')
            .where('departamento.deleted_at IS NULL')
            .where('pais.deleted_at IS NULL')
            .where('user.deleted_at IS NULL')
            .where('tipoUbicacion.deleted_at IS NULL')
            .where('galeria.deleted_at IS NULL')
            .where('inmuebleAreasSociales.deleted_at IS NULL')
            .where('areasSociales.deleted_at IS NULL')
            .where('inmuebleVistas.deleted_at IS NULL')
            .where('vista.deleted_at IS NULL')
            .where('tipoVista.deleted_at IS NULL')
            .where('inmuebleEstados.deleted_at IS NULL')
            .where('estadoProyecto.deleted_at IS NULL')
            .where('tipoMoneda.deleted_at IS NULL')
            .where('inmueble.id = :id', { id })
            .getOne();
        if (!inmueble) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return {
                ...inmueble,
                created_at: (0, date_fns_1.format)(inmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(inmueble.updated_at, 'dd/MM/yyyy'),
                tipoInmueble: inmueble.tipoInmueble ? {
                    ...inmueble.tipoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoOperacion: inmueble.tipoOperacion ? {
                    ...inmueble.tipoOperacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                estadoInmueble: inmueble.estadoInmueble ? {
                    ...inmueble.estadoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                nivelAmoblado: inmueble.nivelAmoblado ? {
                    ...inmueble.nivelAmoblado,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.updated_at), 'dd/MM/yyyy'),
                } : null,
                distrito: inmueble.distrito ? {
                    ...inmueble.distrito,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.updated_at), 'dd/MM/yyyy'),
                    provincia: {
                        ...inmueble.distrito.provincia,
                        created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.created_at), 'dd/MM/yyyy'),
                        updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.updated_at), 'dd/MM/yyyy'),
                        departamento: {
                            ...inmueble.distrito.provincia.departamento,
                            created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.created_at), 'dd/MM/yyyy'),
                            updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.updated_at), 'dd/MM/yyyy'),
                        },
                    },
                } : null,
                user: inmueble.user ? {
                    ...inmueble.user,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.user.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.user.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoUbicacion: inmueble.tipoUbicacion ? {
                    ...inmueble.tipoUbicacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                galeria: inmueble.galeria.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
                inmuebleAreasSociales: inmueble.inmuebleAreasSociales
                    ? inmueble.inmuebleAreasSociales.map(as => ({
                        ...as,
                        created_at: as?.created_at ? (0, date_fns_1.format)(new Date(as.created_at), 'dd/MM/yyyy') : null,
                        updated_at: as?.updated_at ? (0, date_fns_1.format)(new Date(as.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                inmuebleVistas: inmueble.inmuebleVistas
                    ? inmueble.inmuebleVistas.map(vi => ({
                        ...vi,
                        created_at: vi?.created_at ? (0, date_fns_1.format)(new Date(vi.created_at), 'dd/MM/yyyy') : null,
                        updated_at: vi?.updated_at ? (0, date_fns_1.format)(new Date(vi.updated_at), 'dd/MM/yyyy') : null,
                        vista: vi.vista
                            ? {
                                ...vi.vista,
                                created_at: vi.vista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.created_at), 'dd/MM/yyyy') : null,
                                updated_at: vi.vista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.updated_at), 'dd/MM/yyyy') : null,
                                tipoVista: vi.vista.tipoVista
                                    ? {
                                        ...vi.vista.tipoVista,
                                        created_at: vi.vista.tipoVista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.created_at), 'dd/MM/yyyy') : null,
                                        updated_at: vi.vista.tipoVista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.updated_at), 'dd/MM/yyyy') : null,
                                    }
                                    : null,
                            }
                            : null,
                    }))
                    : [],
                inmuebleEstados: inmueble.inmuebleEstados
                    ? inmueble.inmuebleEstados.map(es => ({
                        ...es,
                        created_at: es?.created_at ? (0, date_fns_1.format)(new Date(es.created_at), 'dd/MM/yyyy') : null,
                        updated_at: es?.updated_at ? (0, date_fns_1.format)(new Date(es.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                uniqueTipoVistas: Array.from(new Set(inmueble.inmuebleVistas
                    ?.map(vi => vi.vista?.tipoVista)
                    .filter(tipoVista => tipoVista)
                    .map(tv => JSON.stringify(tv)))).map(str => JSON.parse(str))
            };
        }
    }
    async getDataByUser(user_id) {
        const inmueble = await this.inmuebleRepository.createQueryBuilder('inmueble')
            .leftJoinAndSelect('inmueble.tipoVivienda', 'tipoVivienda', 'tipoVivienda.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoOperacion', 'tipoOperacion', 'tipoOperacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.estadoInmueble', 'estadoInmueble', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.tipoInmueble', 'tipoInmueble', 'tipoInmueble.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.nivelAmoblado', 'nivelAmoblado', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.distrito', 'distrito', 'distrito.deleted_at IS NULL')
            .leftJoinAndSelect('distrito.provincia', 'provincia')
            .leftJoinAndSelect('provincia.departamento', 'departamento')
            .leftJoinAndSelect('departamento.pais', 'pais')
            .innerJoinAndSelect('inmueble.user', 'user', 'user.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoUbicacion', 'tipoUbicacion', 'tipoUbicacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.galeria', 'galeria', 'galeria.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleAreasSociales', 'inmuebleAreasSociales')
            .leftJoinAndSelect('inmuebleAreasSociales.areasSociales', 'areasSociales')
            .leftJoinAndSelect('inmueble.inmuebleVistas', 'inmuebleVistas')
            .leftJoinAndSelect('inmuebleVistas.vista', 'vista', 'vista.deleted_at IS NULL')
            .leftJoinAndSelect('vista.tipoVista', 'tipoVista', 'tipoVista.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleEstados', 'inmuebleEstados')
            .leftJoinAndSelect('inmuebleEstados.estadoProyecto', 'estadoProyecto')
            .leftJoinAndSelect('inmueble.estado', 'estado')
            .innerJoinAndSelect('inmueble.tipoMoneda', 'tipoMoneda', 'tipoMoneda.deleted_at IS NULL')
            .where('inmueble.deleted_at IS NULL')
            .where('tipoVivienda.deleted_at IS NULL')
            .where('tipoOperacion.deleted_at IS NULL')
            .where('estadoInmueble.deleted_at IS NULL')
            .where('tipoInmueble.deleted_at IS NULL')
            .where('nivelAmoblado.deleted_at IS NULL')
            .where('distrito.deleted_at IS NULL')
            .where('provincia.deleted_at IS NULL')
            .where('departamento.deleted_at IS NULL')
            .where('pais.deleted_at IS NULL')
            .where('user.deleted_at IS NULL')
            .where('tipoUbicacion.deleted_at IS NULL')
            .where('galeria.deleted_at IS NULL')
            .where('inmuebleAreasSociales.deleted_at IS NULL')
            .where('areasSociales.deleted_at IS NULL')
            .where('inmuebleVistas.deleted_at IS NULL')
            .where('vista.deleted_at IS NULL')
            .where('tipoVista.deleted_at IS NULL')
            .where('inmuebleEstados.deleted_at IS NULL')
            .where('estadoProyecto.deleted_at IS NULL')
            .where('tipoMoneda.deleted_at IS NULL')
            .where('inmueble.user_id = :user_id', { user_id })
            .orderBy('inmueble.id', 'DESC')
            .getMany();
        if (!inmueble) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = inmueble.map(inmueble => ({
                ...inmueble,
                created_at: (0, date_fns_1.format)(inmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(inmueble.updated_at, 'dd/MM/yyyy'),
                tipoInmueble: inmueble.tipoInmueble ? {
                    ...inmueble.tipoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoOperacion: inmueble.tipoOperacion ? {
                    ...inmueble.tipoOperacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                estadoInmueble: inmueble.estadoInmueble ? {
                    ...inmueble.estadoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                nivelAmoblado: inmueble.nivelAmoblado ? {
                    ...inmueble.nivelAmoblado,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.updated_at), 'dd/MM/yyyy'),
                } : null,
                distrito: inmueble.distrito ? {
                    ...inmueble.distrito,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.updated_at), 'dd/MM/yyyy'),
                    provincia: {
                        ...inmueble.distrito.provincia,
                        created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.created_at), 'dd/MM/yyyy'),
                        updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.updated_at), 'dd/MM/yyyy'),
                        departamento: {
                            ...inmueble.distrito.provincia.departamento,
                            created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.created_at), 'dd/MM/yyyy'),
                            updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.updated_at), 'dd/MM/yyyy'),
                        },
                    },
                } : null,
                user: inmueble.user ? {
                    ...inmueble.user,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.user.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.user.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoUbicacion: inmueble.tipoUbicacion ? {
                    ...inmueble.tipoUbicacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                galeria: inmueble.galeria.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
                inmuebleAreasSociales: inmueble.inmuebleAreasSociales
                    ? inmueble.inmuebleAreasSociales.map(as => ({
                        ...as,
                        created_at: as?.created_at ? (0, date_fns_1.format)(new Date(as.created_at), 'dd/MM/yyyy') : null,
                        updated_at: as?.updated_at ? (0, date_fns_1.format)(new Date(as.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                inmuebleVistas: inmueble.inmuebleVistas
                    ? inmueble.inmuebleVistas.map(vi => ({
                        ...vi,
                        created_at: vi?.created_at ? (0, date_fns_1.format)(new Date(vi.created_at), 'dd/MM/yyyy') : null,
                        updated_at: vi?.updated_at ? (0, date_fns_1.format)(new Date(vi.updated_at), 'dd/MM/yyyy') : null,
                        vista: vi.vista
                            ? {
                                ...vi.vista,
                                created_at: vi.vista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.created_at), 'dd/MM/yyyy') : null,
                                updated_at: vi.vista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.updated_at), 'dd/MM/yyyy') : null,
                                tipoVista: vi.vista.tipoVista
                                    ? {
                                        ...vi.vista.tipoVista,
                                        created_at: vi.vista.tipoVista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.created_at), 'dd/MM/yyyy') : null,
                                        updated_at: vi.vista.tipoVista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.updated_at), 'dd/MM/yyyy') : null,
                                    }
                                    : null,
                            }
                            : null,
                    }))
                    : [],
                inmuebleEstados: inmueble.inmuebleEstados
                    ? inmueble.inmuebleEstados.map(es => ({
                        ...es,
                        created_at: es?.created_at ? (0, date_fns_1.format)(new Date(es.created_at), 'dd/MM/yyyy') : null,
                        updated_at: es?.updated_at ? (0, date_fns_1.format)(new Date(es.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                uniqueTipoVistas: Array.from(new Set(inmueble.inmuebleVistas
                    ?.map(vi => vi.vista?.tipoVista)
                    .filter(tipoVista => tipoVista)
                    .map(tv => JSON.stringify(tv)))).map(str => JSON.parse(str))
            }));
            return {
                data: formattedData
            };
        }
    }
    async searchData(page = 1, limit = 9, params) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const query = this.inmuebleRepository.createQueryBuilder('inmueble')
            .leftJoinAndSelect('inmueble.tipoVivienda', 'tipoVivienda', 'tipoVivienda.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoOperacion', 'tipoOperacion', 'tipoOperacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.estadoInmueble', 'estadoInmueble', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.tipoInmueble', 'tipoInmueble', 'tipoInmueble.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.nivelAmoblado', 'nivelAmoblado', 'estadoInmueble.deleted_at IS NULL')
            .innerJoinAndSelect('inmueble.distrito', 'distrito', 'distrito.deleted_at IS NULL')
            .leftJoinAndSelect('distrito.provincia', 'provincia')
            .leftJoinAndSelect('provincia.departamento', 'departamento')
            .leftJoinAndSelect('departamento.pais', 'pais')
            .innerJoinAndSelect('inmueble.user', 'user', 'user.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.tipoUbicacion', 'tipoUbicacion', 'tipoUbicacion.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.galeria', 'galeria', 'galeria.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleAreasSociales', 'inmuebleAreasSociales', 'inmuebleAreasSociales.deleted_at IS NULL')
            .leftJoinAndSelect('inmuebleAreasSociales.areasSociales', 'areasSociales', 'areasSociales.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleVistas', 'inmuebleVistas')
            .leftJoinAndSelect('inmuebleVistas.vista', 'vista', 'vista.deleted_at IS NULL')
            .leftJoinAndSelect('vista.tipoVista', 'tipoVista', 'tipoVista.deleted_at IS NULL')
            .leftJoinAndSelect('inmueble.inmuebleEstados', 'inmuebleEstados')
            .leftJoinAndSelect('inmuebleEstados.estadoProyecto', 'estadoProyecto')
            .leftJoinAndSelect('inmueble.estado', 'estado')
            .innerJoinAndSelect('inmueble.tipoMoneda', 'tipoMoneda', 'tipoMoneda.deleted_at IS NULL')
            .where('inmueble.deleted_at IS NULL')
            .where('tipoVivienda.deleted_at IS NULL')
            .where('tipoOperacion.deleted_at IS NULL')
            .where('estadoInmueble.deleted_at IS NULL')
            .where('tipoInmueble.deleted_at IS NULL')
            .where('nivelAmoblado.deleted_at IS NULL')
            .where('distrito.deleted_at IS NULL')
            .where('provincia.deleted_at IS NULL')
            .where('departamento.deleted_at IS NULL')
            .where('pais.deleted_at IS NULL')
            .where('user.deleted_at IS NULL')
            .where('tipoUbicacion.deleted_at IS NULL')
            .where('galeria.deleted_at IS NULL')
            .where('inmuebleAreasSociales.deleted_at IS NULL')
            .where('areasSociales.deleted_at IS NULL')
            .where('inmuebleVistas.deleted_at IS NULL')
            .where('vista.deleted_at IS NULL')
            .where('tipoVista.deleted_at IS NULL')
            .where('inmuebleEstados.deleted_at IS NULL')
            .where('estadoProyecto.deleted_at IS NULL')
            .where('tipoMoneda.deleted_at IS NULL');
        if (params.proyecto) {
            query.andWhere('inmueble.proyecto = :proyecto', { proyecto: params.proyecto });
        }
        if (params.condominio) {
            query.andWhere('inmueble.condominio = :condominio', { condominio: params.condominio });
        }
        if (params.ambientes) {
            query.andWhere('inmueble.ambientes >= :ambientes', { ambientes: params.ambientes });
        }
        if (params.dormitorios) {
            query.andWhere('inmueble.dormitorios >= :dormitorios', { dormitorios: params.dormitorios });
        }
        if (params.bathroom) {
            query.andWhere('inmueble.bathroom >= :bathroom', { bathroom: params.bathroom });
        }
        if (params.cocheras) {
            query.andWhere('inmueble.cocheras >= :cocheras', { cocheras: params.cocheras });
        }
        if (params.estadosProyecto && params.estadosProyecto.length > 0) {
            query.innerJoin('inmueble.inmuebleEstados', 'ie')
                .andWhere('ie.estado_proyecto_id IN (:...estados)', { estados: params.estadosProyecto.map(e => e.estado_proyecto_id) });
        }
        if (params.inmuebleVistas && params.inmuebleVistas.length > 0) {
            query.innerJoin('inmueble.inmuebleVistas', 'iv')
                .andWhere('iv.vista_id IN (:...vistas)', { vistas: params.inmuebleVistas.map(e => e.vista_id) });
        }
        if (params.tipo_vivienda_id) {
            query.andWhere('inmueble.tipo_vivienda_id = :tipo_vivienda_id', { tipo_vivienda_id: params.tipo_vivienda_id });
        }
        if (params.tipo_operacion_id) {
            query.andWhere('inmueble.tipo_operacion_id = :tipo_operacion_id', { tipo_operacion_id: params.tipo_operacion_id });
        }
        if (params.tipo_inmueble_id) {
            query.andWhere('inmueble.tipo_inmueble_id = :tipo_inmueble_id', { tipo_inmueble_id: params.tipo_inmueble_id });
        }
        if (params.nivel_amoblado_id) {
            query.andWhere('inmueble.nivel_amoblado_id = :nivel_amoblado_id', { nivel_amoblado_id: params.nivel_amoblado_id });
        }
        if (params.distrito_id) {
            query.andWhere('inmueble.distrito_id = :distrito_id', { distrito_id: params.distrito_id });
        }
        if (params.user_id) {
            query.andWhere('inmueble.user_id = :user_id', { user_id: params.user_id });
        }
        if (params.tipo_ubicacion_id) {
            query.andWhere('inmueble.tipo_ubicacion_id = :tipo_ubicacion_id', { tipo_ubicacion_id: params.tipo_ubicacion_id });
        }
        if (params.titulo) {
            query.andWhere('inmueble.titulo like :titulo', { titulo: `%${params.titulo}%` });
        }
        if (params.precioMin && params.precioMax) {
            query.andWhere('inmueble.precio BETWEEN :precioMin AND :precioMax', {
                precioMin: params.precioMin,
                precioMax: params.precioMax
            });
        }
        else if (params.precioMin) {
            query.andWhere('inmueble.precio >= :precioMin', { precioMin: params.precioMin });
        }
        else if (params.precioMax) {
            query.andWhere('inmueble.precio <= :precioMax', { precioMax: params.precioMax });
        }
        if (params.fecha_ini && params.fecha_fin) {
            query.andWhere('inmueble.created_at BETWEEN :fecha_ini AND :fecha_fin', {
                fecha_ini: params.fecha_ini,
                fecha_fin: params.fecha_fin,
            });
        }
        else if (params.fecha_ini) {
            query.andWhere('inmueble.created_at >= :fecha_ini', { fecha_ini: params.fecha_ini });
        }
        else if (params.fechaMax) {
            query.andWhere('inmueble.created_at <= :fecha_fin', { fecha_fin: params.fecha_fin });
        }
        if (params.areaTotalMin && params.areaTotalMax) {
            query.andWhere('inmueble.area BETWEEN :areaTotalMin AND :areaTotalMax', {
                areaTotalMin: params.areaTotalMin,
                areaTotalMax: params.areaTotalMax
            });
        }
        else if (params.areaTotalMin) {
            query.andWhere('inmueble.area >= :areaTotalMin', { areaTotalMin: params.areaTotalMin });
        }
        else if (params.areaTotalMax) {
            query.andWhere('inmueble.area <= :areaTotalMax', { areaTotalMax: params.areaTotalMax });
        }
        if (params.areaTechadaMin && params.areaTechadaMax) {
            query.andWhere('inmueble.area_techada BETWEEN :areaTechadaMin AND :areaTechadaMax', {
                areaTechadaMin: params.areaTechadaMin,
                areaTechadaMax: params.areaTechadaMax
            });
        }
        else if (params.areaTechadaMin) {
            query.andWhere('inmueble.area_techada >= :areaTechadaMin', { areaTechadaMin: params.areaTechadaMin });
        }
        else if (params.areaTechadaMax) {
            query.andWhere('inmueble.area_techada <= :areaTechadaMax', { areaTechadaMax: params.areaTechadaMax });
        }
        if (params.antiguedadMin && params.antiguedadMax) {
            query.andWhere('inmueble.antiguedad BETWEEN :antiguedadMin AND :antiguedadMax', {
                antiguedadMin: params.antiguedadMin,
                antiguedadMax: params.antiguedadMax
            });
        }
        else if (params.antiguedadMin) {
            query.andWhere('inmueble.antiguedad >= :antiguedadMin', { antiguedadMin: params.antiguedadMin });
        }
        else if (params.antiguedadMax) {
            query.andWhere('inmueble.antiguedad <= :antiguedadMax', { antiguedadMax: params.antiguedadMax });
        }
        const [data, total] = await query
            .skip(offset)
            .take(limit)
            .orderBy('inmueble.id', 'DESC')
            .getManyAndCount();
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(inmueble => ({
                ...inmueble,
                created_at: (0, date_fns_1.format)(inmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(inmueble.updated_at, 'dd/MM/yyyy'),
                tipoInmueble: inmueble.tipoInmueble ? {
                    ...inmueble.tipoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoOperacion: inmueble.tipoOperacion ? {
                    ...inmueble.tipoOperacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoOperacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                estadoInmueble: inmueble.estadoInmueble ? {
                    ...inmueble.estadoInmueble,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.estadoInmueble.updated_at), 'dd/MM/yyyy'),
                } : null,
                nivelAmoblado: inmueble.nivelAmoblado ? {
                    ...inmueble.nivelAmoblado,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.nivelAmoblado.updated_at), 'dd/MM/yyyy'),
                } : null,
                distrito: inmueble.distrito ? {
                    ...inmueble.distrito,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.updated_at), 'dd/MM/yyyy'),
                    provincia: {
                        ...inmueble.distrito.provincia,
                        created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.created_at), 'dd/MM/yyyy'),
                        updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.updated_at), 'dd/MM/yyyy'),
                        departamento: {
                            ...inmueble.distrito.provincia.departamento,
                            created_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.created_at), 'dd/MM/yyyy'),
                            updated_at: (0, date_fns_1.format)(new Date(inmueble.distrito.provincia.departamento.updated_at), 'dd/MM/yyyy'),
                        },
                    },
                } : null,
                user: inmueble.user ? {
                    ...inmueble.user,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.user.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.user.updated_at), 'dd/MM/yyyy'),
                } : null,
                tipoUbicacion: inmueble.tipoUbicacion ? {
                    ...inmueble.tipoUbicacion,
                    created_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(inmueble.tipoUbicacion.updated_at), 'dd/MM/yyyy'),
                } : null,
                galeria: inmueble.galeria.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
                inmuebleAreasSociales: inmueble.inmuebleAreasSociales
                    ? inmueble.inmuebleAreasSociales.map(as => ({
                        ...as,
                        created_at: as?.created_at ? (0, date_fns_1.format)(new Date(as.created_at), 'dd/MM/yyyy') : null,
                        updated_at: as?.updated_at ? (0, date_fns_1.format)(new Date(as.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                inmuebleVistas: inmueble.inmuebleVistas
                    ? inmueble.inmuebleVistas.map(vi => ({
                        ...vi,
                        created_at: vi?.created_at ? (0, date_fns_1.format)(new Date(vi.created_at), 'dd/MM/yyyy') : null,
                        updated_at: vi?.updated_at ? (0, date_fns_1.format)(new Date(vi.updated_at), 'dd/MM/yyyy') : null,
                        vista: vi.vista
                            ? {
                                ...vi.vista,
                                created_at: vi.vista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.created_at), 'dd/MM/yyyy') : null,
                                updated_at: vi.vista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.updated_at), 'dd/MM/yyyy') : null,
                                tipoVista: vi.vista.tipoVista
                                    ? {
                                        ...vi.vista.tipoVista,
                                        created_at: vi.vista.tipoVista?.created_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.created_at), 'dd/MM/yyyy') : null,
                                        updated_at: vi.vista.tipoVista?.updated_at ? (0, date_fns_1.format)(new Date(vi.vista.tipoVista.updated_at), 'dd/MM/yyyy') : null,
                                    }
                                    : null,
                            }
                            : null,
                    }))
                    : [],
                inmuebleEstados: inmueble.inmuebleEstados
                    ? inmueble.inmuebleEstados.map(es => ({
                        ...es,
                        created_at: es?.created_at ? (0, date_fns_1.format)(new Date(es.created_at), 'dd/MM/yyyy') : null,
                        updated_at: es?.updated_at ? (0, date_fns_1.format)(new Date(es.updated_at), 'dd/MM/yyyy') : null
                    }))
                    : [],
                uniqueTipoVistas: Array.from(new Set(inmueble.inmuebleVistas
                    ?.map(vi => vi.vista?.tipoVista)
                    .filter(tipoVista => tipoVista)
                    .map(tv => JSON.stringify(tv)))).map(str => JSON.parse(str))
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async createInmueble(inmuebleData) {
        const queryRunner = this.dataSource.createQueryRunner();
        await queryRunner.connect();
        await queryRunner.startTransaction();
        try {
            const inmuebleFound = await queryRunner.manager.findOne(inmueble_entity_1.Inmueble, {
                where: {
                    latitud: inmuebleData.latitud,
                    longitud: inmuebleData.longitud,
                    titulo: inmuebleData.titulo,
                    direccion: inmuebleData.direccion,
                    deleted_at: null
                }
            });
            if (inmuebleFound) {
                console.warn('⚠ Inmueble ya existe');
                await queryRunner.rollbackTransaction();
                throw new common_1.HttpException('El inmueble ya existe', common_1.HttpStatus.CONFLICT);
            }
            const inmueble = queryRunner.manager.create(inmueble_entity_1.Inmueble, inmuebleData);
            const data = await queryRunner.manager.save(inmueble);
            if (inmuebleData.areaSocial?.length) {
                await queryRunner.manager.save('InmuebleAreasSociales', inmuebleData.areaSocial.map(area => ({
                    inmueble_id: data.id,
                    areas_sociales_id: area.areas_sociales_id
                })));
            }
            if (inmuebleData.galeria?.length) {
                await queryRunner.manager.save('Galeria', inmuebleData.galeria.map(img => ({ inmueble_id: data.id, ...img })));
            }
            if (inmuebleData.inmuebleVistas?.length) {
                await queryRunner.manager.save('InmuebleVistas', inmuebleData.inmuebleVistas.map(vis => ({
                    inmueble_id: data.id,
                    vista_id: vis.vista_id
                })));
            }
            if (inmuebleData.estadosProyecto?.length) {
                await queryRunner.manager.save('InmuebleEstados', inmuebleData.estadosProyecto.map(estado => ({
                    inmueble_id: data.id,
                    estado_proyecto_id: estado.estado_proyecto_id
                })));
            }
            await queryRunner.commitTransaction();
            console.log('✅ Transacción confirmada, buscando inmueble con ID:', data.id);
            const formattedData = await this.getDataById(data.id);
            return { message: 'Inmueble creado exitosamente', status: common_1.HttpStatus.CREATED, data: formattedData };
        }
        catch (error) {
            console.error('❌ Error al crear inmueble:', error);
            await queryRunner.rollbackTransaction();
            throw new common_1.HttpException('Error al crear inmueble', common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
        finally {
            await queryRunner.release();
        }
    }
    async updateData(id, inmueble) {
        const isValidDate = (date) => {
            return date && !isNaN(new Date(date).getTime());
        };
        const safeFormat = (date, formatString) => {
            return isValidDate(date) ? (0, date_fns_1.format)(new Date(date), formatString) : 'Fecha no válida';
        };
        const inmuebleFound = await this.inmuebleRepository.findOne({
            where: {
                id: id
            },
            relations: ['tipoVivienda', 'tipoOperacion', 'tipoInmueble', 'nivelAmoblado', 'distrito', 'user', 'tipoUbicacion', 'estadoInmueble', 'estado', 'tipoMoneda', 'galeria', 'inmuebleAreasSociales'],
        });
        if (!inmuebleFound) {
            return new common_1.HttpException('Inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const { created_at } = inmuebleFound;
            const updateInmueble = Object.assign(inmuebleFound, inmueble);
            updateInmueble.updated_at = new Date();
            updateInmueble.created_at = created_at;
            if (inmueble.tipo_vivienda_id && inmueble.tipo_vivienda_id !== inmuebleFound.tipoVivienda?.id) {
                const tipoVivienda = await this.tipoViviendaRepository.findOne({
                    where: { id: inmueble.vista_id },
                });
                if (!tipoVivienda) {
                    throw new common_1.HttpException('Tipo vivienda no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.tipoVivienda = tipoVivienda;
            }
            if (inmueble.tipo_operacion_id && inmueble.tipo_operacion_id !== inmuebleFound.tipoOperacion?.id) {
                const tipoOperacion = await this.tipoOperacionRepository.findOne({
                    where: { id: inmueble.tipo_operacion_id },
                });
                if (!tipoOperacion) {
                    throw new common_1.HttpException('Tipo operacion no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.tipoOperacion = tipoOperacion;
            }
            if (inmueble.tipo_inmueble_id && inmueble.tipo_inmueble_id !== inmuebleFound.tipoInmueble?.id) {
                const tipoInmueble = await this.tipoInmuebleRepository.findOne({
                    where: { id: inmueble.tipo_inmueble_id },
                });
                if (!tipoInmueble) {
                    throw new common_1.HttpException('Tipo inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.tipoInmueble = tipoInmueble;
            }
            if (inmueble.nivel_amoblado_id && inmueble.nivel_amoblado_id !== inmuebleFound.nivelAmoblado?.id) {
                const nivelAmoblado = await this.nivelAmobladoRepository.findOne({
                    where: { id: inmueble.nivel_amoblado_id },
                });
                if (!nivelAmoblado) {
                    throw new common_1.HttpException('Nivel amoblado no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.nivelAmoblado = nivelAmoblado;
            }
            if (inmueble.distrito_id && inmueble.distrito_id !== inmuebleFound.distrito?.id) {
                const distrito = await this.distritoRepository.findOne({
                    where: { id: inmueble.distrito_id },
                });
                if (!distrito) {
                    throw new common_1.HttpException('Distrito no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.distrito = distrito;
            }
            if (inmueble.user_id && inmueble.user_id !== inmuebleFound.user?.id) {
                const user = await this.userRepository.findOne({
                    where: { id: inmueble.user_id },
                });
                if (!user) {
                    throw new common_1.HttpException('User no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.user = user;
            }
            if (inmueble.tipo_ubicacion_id && inmueble.tipo_ubicacion_id !== inmuebleFound.tipoUbicacion?.id) {
                const tipoUbicacion = await this.tipoUbicacionRepository.findOne({
                    where: { id: inmueble.tipo_ubicacion_id },
                });
                if (!tipoUbicacion) {
                    throw new common_1.HttpException('Tipo ubicacion no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.tipoUbicacion = tipoUbicacion;
            }
            if (inmueble.estado_inmueble_id && inmueble.estado_inmueble_id !== inmuebleFound.estadoInmueble?.id) {
                const estadoInmueble = await this.estadoInmuebleRepository.findOne({
                    where: { id: inmueble.estado_inmueble_id },
                });
                if (!estadoInmueble) {
                    throw new common_1.HttpException('Estado Inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.estadoInmueble = estadoInmueble;
            }
            if (inmueble.estado_id && inmueble.estado_id !== inmuebleFound.estado?.id) {
                const estado = await this.estadoRepository.findOne({
                    where: { id: inmueble.estado_id },
                });
                if (!estado) {
                    throw new common_1.HttpException('Estado no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.estado = estado;
            }
            if (inmueble.tipo_moneda_id && inmueble.tipo_moneda_id !== inmuebleFound.tipoMoneda?.id) {
                const tipoMoneda = await this.tipoMonedaRepository.findOne({
                    where: { id: inmueble.tipo_moneda_id },
                });
                if (!tipoMoneda) {
                    throw new common_1.HttpException('Tipo inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
                }
                updateInmueble.tipoMoneda = tipoMoneda;
            }
            let updatedGaleria = inmuebleFound.galeria ? [...inmuebleFound.galeria] : [];
            if (inmueble.galeria && Array.isArray(inmueble.galeria)) {
                for (const imagen of inmueble.galeria) {
                    if (imagen.id) {
                        const imagenExistente = await this.galeriaRepository.findOne({ where: { id: imagen.id } });
                        if (imagenExistente) {
                            updatedGaleria.push(imagenExistente);
                        }
                    }
                    else if (imagen.url_desktop) {
                        const nuevaImagen = this.galeriaRepository.create({
                            url_desktop: imagen.url_desktop,
                            url_mobile: imagen.url_mobile ?? null,
                            inmueble: inmuebleFound,
                        });
                        const imagenGuardada = await this.galeriaRepository.save(nuevaImagen);
                        updatedGaleria.push(imagenGuardada);
                    }
                }
            }
            updateInmueble.galeria = [...updatedGaleria];
            let updatedAreasSociales = inmuebleFound.inmuebleAreasSociales ? [...inmuebleFound.inmuebleAreasSociales] : [];
            if (inmueble.inmuebleAreasSociales && Array.isArray(inmueble.inmuebleAreasSociales)) {
                for (const inmuebleAreasSocial of inmueble.inmuebleAreasSociales) {
                    if (inmuebleAreasSocial.id == null && inmuebleAreasSocial.deleted_at == null) {
                        const nuevaInmuebleAreasSocial = this.inmuebleAreasSocialesRepository.create({
                            inmueble_id: inmuebleAreasSocial.inmueble_id,
                            areas_sociales_id: inmuebleAreasSocial.areas_sociales_id,
                        });
                        const inmuebleAreasSocialGuardada = await this.inmuebleAreasSocialesRepository.save(nuevaInmuebleAreasSocial);
                        updatedAreasSociales.push(inmuebleAreasSocialGuardada);
                    }
                    else if (inmuebleAreasSocial.id !== null && inmuebleAreasSocial.deleted_at !== null) {
                        await this.inmuebleAreasSocialesRepository.update(inmuebleAreasSocial.id, { deleted_at: new Date() });
                        const index = updatedAreasSociales.findIndex(area => area.id === inmuebleAreasSocial.id);
                        if (index !== -1) {
                            updatedAreasSociales[index].deleted_at = new Date();
                        }
                    }
                    else {
                    }
                }
            }
            let updatedInmuebleEstados = inmuebleFound.inmuebleEstados ? [...inmuebleFound.inmuebleEstados] : [];
            if (inmueble.inmuebleEstados && Array.isArray(inmueble.inmuebleEstados)) {
                for (const inmuebleEstado of inmueble.inmuebleEstados) {
                    if (inmuebleEstado.id == null && inmuebleEstado.deleted_at == null) {
                        const nuevaInmuebleEstado = this.inmuebleEstadosRepository.create({
                            inmueble_id: inmuebleEstado.inmueble_id,
                            estado_proyecto_id: inmuebleEstado.estado_proyecto_id,
                        });
                        const inmuebleEstadosGuardada = await this.inmuebleEstadosRepository.save(nuevaInmuebleEstado);
                        updatedInmuebleEstados.push(inmuebleEstadosGuardada);
                    }
                    else if (inmuebleEstado.id !== null && inmuebleEstado.deleted_at !== null) {
                        await this.inmuebleEstadosRepository.update(inmuebleEstado.id, { deleted_at: new Date() });
                        const index = updatedInmuebleEstados.findIndex(area => area.id === inmuebleEstado.id);
                        if (index !== -1) {
                            updatedInmuebleEstados[index].deleted_at = new Date();
                        }
                    }
                    else {
                    }
                }
            }
            let updatedInmuebleVistas = inmuebleFound.inmuebleVistas ? [...inmuebleFound.inmuebleVistas] : [];
            if (inmueble.inmuebleVistas && Array.isArray(inmueble.inmuebleVistas)) {
                for (const inmuebleVista of inmueble.inmuebleVistas) {
                    if (inmuebleVista.id == null && inmuebleVista.deleted_at == null) {
                        const nuevaInmuebleVista = this.inmuebleVistasRepository.create({
                            inmueble_id: inmuebleVista.inmueble_id,
                            vista_id: inmuebleVista.vista_id,
                        });
                        const inmuebleVistasGuardada = await this.inmuebleVistasRepository.save(nuevaInmuebleVista);
                        updatedInmuebleVistas.push(inmuebleVistasGuardada);
                    }
                    else if (inmuebleVista.id !== null && inmuebleVista.deleted_at !== null) {
                        await this.inmuebleVistasRepository.update(inmuebleVista.id, { deleted_at: new Date() });
                        const index = updatedInmuebleVistas.findIndex(area => area.id === inmuebleVista.id);
                        if (index !== -1) {
                            updatedInmuebleVistas[index].deleted_at = new Date();
                        }
                    }
                    else {
                    }
                }
            }
            const updInmueble = {
                id: updateInmueble.id,
                titulo: updateInmueble.titulo,
                direccion: updateInmueble.direccion,
                descripcion: updateInmueble.descripcion,
                bathroom: updateInmueble.bathroom,
                dormitorios: updateInmueble.dormitorios,
                cocheras: updateInmueble.cocheras,
                ambientes: updateInmueble.ambientes,
                piso: updateInmueble.piso,
                area: updateInmueble.area,
                area_techada: updateInmueble.area_techada,
                antiguedad: updateInmueble.antiguedad,
                tipo_moneda_id: updateInmueble.tipo_moneda_id,
                precio: updateInmueble.precio,
                precio_mantenimiento: updateInmueble.precio_mantenimiento,
                latitud: updateInmueble.latitud,
                longitud: updateInmueble.longitud,
                zoom: updateInmueble.zoom,
                mascotas: updateInmueble.mascotas,
                balcon: updateInmueble.balcon,
                estreno: updateInmueble.estreno,
                deposito: updateInmueble.deposito,
                condominio: updateInmueble.condominio,
                cuarto_servicio: updateInmueble.cuarto_servicio,
                terraza: updateInmueble.terraza,
                ascensor: updateInmueble.ascensor,
                proyecto: updateInmueble.proyecto,
                areas_sociales: updateInmueble.areas_sociales,
                tipo_vivienda_id: updateInmueble.tipo_vivienda_id,
                tipo_operacion_id: updateInmueble.tipo_operacion_id,
                estado_inmueble_id: updateInmueble.estado_inmueble_id,
                tipo_inmueble_id: updateInmueble.tipo_inmueble_id,
                nivel_amoblado_id: updateInmueble.nivel_amoblado_id,
                tipo_ubicacion_id: updateInmueble.tipo_ubicacion_id,
                distrito_id: updateInmueble.distrito_id,
            };
            console.log(updateInmueble.inmuebleAreasSociales);
            const dataSave = await this.inmuebleRepository.save(updInmueble);
            const data = await this.getDataById(dataSave.id);
            return {
                data: data,
                inmuebleDto: inmueble,
                inmuebleFound: inmuebleFound,
                updateInmueble: updateInmueble,
                status: common_1.HttpStatus.OK,
                message: 'Inmueble actualizado exitosamente',
            };
        }
    }
    async deleteData(id) {
        const rs = await this.inmuebleRepository.createQueryBuilder()
            .update(inmueble_entity_1.Inmueble)
            .set({ deleted_at: () => 'CURRENT_TIMESTAMP' })
            .where('id = :id', { id })
            .execute();
        if (rs.affected === 0) {
            console.log(rs.affected);
            return new common_1.HttpException('Inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return rs;
        }
    }
};
exports.InmuebleService = InmuebleService;
exports.InmuebleService = InmuebleService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(inmueble_entity_1.Inmueble)),
    __param(2, (0, typeorm_1.InjectRepository)(vista_entity_1.Vista)),
    __param(3, (0, typeorm_1.InjectRepository)(tipo_vivienda_entity_1.TipoVivienda)),
    __param(4, (0, typeorm_1.InjectRepository)(estado_proyecto_entity_1.EstadoProyecto)),
    __param(5, (0, typeorm_1.InjectRepository)(tipo_operacion_entity_1.TipoOperacion)),
    __param(6, (0, typeorm_1.InjectRepository)(estado_inmueble_entity_1.EstadoInmueble)),
    __param(7, (0, typeorm_1.InjectRepository)(tipo_inmueble_entity_1.TipoInmueble)),
    __param(8, (0, typeorm_1.InjectRepository)(nivel_amoblado_entity_1.NivelAmoblado)),
    __param(9, (0, typeorm_1.InjectRepository)(distrito_entity_1.Distrito)),
    __param(10, (0, typeorm_1.InjectRepository)(user_entity_1.User)),
    __param(11, (0, typeorm_1.InjectRepository)(tipo_ubicacion_entity_1.TipoUbicacion)),
    __param(12, (0, typeorm_1.InjectRepository)(tipo_moneda_entity_1.TipoMoneda)),
    __param(13, (0, typeorm_1.InjectRepository)(estado_entity_1.Estado)),
    __param(14, (0, typeorm_1.InjectRepository)(galeria_entity_1.Galeria)),
    __param(15, (0, typeorm_1.InjectRepository)(inmueble_areas_sociales_entity_1.InmuebleAreasSociales)),
    __param(16, (0, typeorm_1.InjectRepository)(inmueble_estados_entity_1.InmuebleEstados)),
    __param(17, (0, typeorm_1.InjectRepository)(inmueble_vistas_entity_1.InmuebleVistas)),
    __metadata("design:paramtypes", [typeorm_2.Repository, typeorm_2.DataSource,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository])
], InmuebleService);
//# sourceMappingURL=inmueble.service.js.map