"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NivelAmobladoService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const nivel_amoblado_entity_1 = require("./nivel-amoblado.entity");
const typeorm_2 = require("typeorm");
const date_fns_1 = require("date-fns");
let NivelAmobladoService = class NivelAmobladoService {
    constructor(nivelAmobladoRepository) {
        this.nivelAmobladoRepository = nivelAmobladoRepository;
    }
    async getDataAll() {
        const nivelAmoblado = await this.nivelAmobladoRepository.createQueryBuilder('nivel_amoblado')
            .andWhere('nivel_amoblado.deleted_at IS NULL')
            .getMany();
        if (!nivelAmoblado.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return nivelAmoblado.map(nivelAmoblado => ({
                ...nivelAmoblado,
                created_at: (0, date_fns_1.format)(nivelAmoblado.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(nivelAmoblado.updated_at, 'dd/MM/yyyy'),
            }));
        }
    }
    async getData(page = 1, limit = 2) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const [data, total] = await this.nivelAmobladoRepository.createQueryBuilder('nivel_amoblado')
            .andWhere('nivel_amoblado.deleted_at IS NULL')
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(nivelAmoblado => ({
                ...nivelAmoblado,
                created_at: (0, date_fns_1.format)(nivelAmoblado.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(nivelAmoblado.updated_at, 'dd/MM/yyyy'),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async searchData(page = 1, limit = 9, params) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const query = this.nivelAmobladoRepository.createQueryBuilder('nivel_amoblado')
            .andWhere('nivel_amoblado.deleted_at IS NULL');
        if (params.nombre) {
            console.log('params:');
            console.log(params);
            query.andWhere('nivel_amoblado.nombre LIKE :nombre', { nombre: `%${params.nombre}%` });
        }
        const [data, total] = await query
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        console.log('data:');
        console.log(data);
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(nivelAmoblado => ({
                ...nivelAmoblado,
                created_at: (0, date_fns_1.format)(nivelAmoblado.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(nivelAmoblado.updated_at, 'dd/MM/yyyy'),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async getDataById(id) {
        const nivelAmoblado = await this.nivelAmobladoRepository.createQueryBuilder('nivel_amoblado')
            .andWhere('nivel_amoblado.deleted_at IS NULL')
            .where('nivel_amoblado.id = :id', { id })
            .getOne();
        if (!nivelAmoblado) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return {
                ...nivelAmoblado,
                created_at: (0, date_fns_1.format)(nivelAmoblado.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(nivelAmoblado.updated_at, 'dd/MM/yyyy'),
            };
        }
    }
    async createData(nivelAmoblado) {
        const nivelAmobladoFound = await this.nivelAmobladoRepository.findOne({
            where: {
                nombre: nivelAmoblado.nombre,
                deleted_at: null
            }
        });
        if (nivelAmobladoFound) {
            return new common_1.HttpException({
                status: common_1.HttpStatus.CONFLICT,
                message: 'Estado de proyecto ya existe',
            }, common_1.HttpStatus.CONFLICT);
        }
        else {
            const newNivelAmoblado = this.nivelAmobladoRepository.create(nivelAmoblado);
            const savedNivelAmoblado = await this.nivelAmobladoRepository.save(newNivelAmoblado);
            const formattedData = {
                ...savedNivelAmoblado,
                created_at: (0, date_fns_1.format)(savedNivelAmoblado.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(savedNivelAmoblado.updated_at, 'dd/MM/yyyy')
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Nivel amoblado creado exitosamente',
            };
        }
    }
    async updateData(id, nivelAmoblado) {
        const nivelAmobladoFound = await this.nivelAmobladoRepository.findOne({
            where: {
                id: id
            }
        });
        if (!nivelAmobladoFound) {
            return new common_1.HttpException('Tipo de inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const { created_at } = nivelAmobladoFound;
            const updateNivelAmoblado = Object.assign(nivelAmobladoFound, nivelAmoblado);
            updateNivelAmoblado.updated_at = new Date();
            updateNivelAmoblado.created_at = created_at;
            const data = await this.nivelAmobladoRepository.save(updateNivelAmoblado);
            const formattedData = {
                ...data,
                created_at: (0, date_fns_1.format)(new Date(data.created_at), 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(new Date(data.updated_at), 'dd/MM/yyyy')
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Nivel amoblado actualizado exitosamente',
            };
        }
    }
    async deleteData(id) {
        const rs = await this.nivelAmobladoRepository.createQueryBuilder()
            .update(nivel_amoblado_entity_1.NivelAmoblado)
            .set({ deleted_at: () => 'CURRENT_TIMESTAMP' })
            .where('id = :id', { id })
            .execute();
        if (rs.affected === 0) {
            console.log(rs.affected);
            return new common_1.HttpException('Nivel Amoblado no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return rs;
        }
    }
};
exports.NivelAmobladoService = NivelAmobladoService;
exports.NivelAmobladoService = NivelAmobladoService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(nivel_amoblado_entity_1.NivelAmoblado)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], NivelAmobladoService);
//# sourceMappingURL=nivel-amoblado.service.js.map