"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaisService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const pais_entity_1 = require("./pais.entity");
const typeorm_2 = require("typeorm");
const date_fns_1 = require("date-fns");
let PaisService = class PaisService {
    constructor(paisRepository) {
        this.paisRepository = paisRepository;
    }
    async getDataAll() {
        const pais = await this.paisRepository.createQueryBuilder('pais')
            .leftJoinAndSelect('pais.departamento', 'departamento')
            .andWhere('departamento.deleted_at IS NULL')
            .andWhere('pais.deleted_at IS NULL')
            .getMany();
        if (!pais.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return pais.map(pais => ({
                ...pais,
                created_at: (0, date_fns_1.format)(pais.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(pais.updated_at, 'dd/MM/yyyy'),
                departamento: pais.departamento.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            }));
        }
    }
    async getData(page = 1, limit = 2) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const [data, total] = await this.paisRepository.createQueryBuilder('pais')
            .leftJoinAndSelect('pais.departamento', 'departamento')
            .andWhere('departamento.deleted_at IS NULL')
            .andWhere('pais.deleted_at IS NULL')
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(pais => ({
                ...pais,
                created_at: (0, date_fns_1.format)(pais.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(pais.updated_at, 'dd/MM/yyyy'),
                departamento: pais.departamento.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async searchData(page = 1, limit = 9, params) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const query = this.paisRepository.createQueryBuilder('pais')
            .leftJoinAndSelect('pais.departamento', 'departamento')
            .andWhere('departamento.deleted_at IS NULL')
            .andWhere('pais.deleted_at IS NULL');
        if (params.nombre) {
            console.log('params:');
            console.log(params);
            query.andWhere('pais.nombre LIKE :nombre', { nombre: `%${params.nombre}%` });
        }
        const [data, total] = await query
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        console.log('data:');
        console.log(data);
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(pais => ({
                ...pais,
                created_at: (0, date_fns_1.format)(pais.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(pais.updated_at, 'dd/MM/yyyy'),
                departamento: pais.departamento.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async getDataById(id) {
        const pais = await this.paisRepository.createQueryBuilder('pais')
            .leftJoinAndSelect('pais.departamento', 'departamento')
            .andWhere('departamento.deleted_at IS NULL')
            .andWhere('pais.deleted_at IS NULL')
            .where('pais.id = :id', { id })
            .getOne();
        if (!pais) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return {
                ...pais,
                created_at: (0, date_fns_1.format)(pais.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(pais.updated_at, 'dd/MM/yyyy'),
                departamento: pais.departamento.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            };
        }
    }
    async createData(pais) {
        const paisFound = await this.paisRepository.findOne({
            where: {
                nombre: pais.nombre,
                deleted_at: null
            }
        });
        if (paisFound) {
            return new common_1.HttpException({
                status: common_1.HttpStatus.CONFLICT,
                message: 'Estado de proyecto ya existe',
            }, common_1.HttpStatus.CONFLICT);
        }
        else {
            const newPais = this.paisRepository.create(pais);
            const savedPais = await this.paisRepository.save(newPais);
            const formattedData = {
                ...savedPais,
                created_at: (0, date_fns_1.format)(savedPais.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(savedPais.updated_at, 'dd/MM/yyyy'),
                departamento: savedPais.departamento
                    ? savedPais.departamento.map((us) => ({
                        ...us,
                        created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                        updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                    }))
                    : [],
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Pais creado exitosamente',
            };
        }
    }
    async updateData(id, pais) {
        const paisFound = await this.paisRepository.findOne({
            where: {
                id: id
            }
        });
        if (!paisFound) {
            return new common_1.HttpException('Pais no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const { created_at } = paisFound;
            const updatePais = Object.assign(paisFound, pais);
            updatePais.updated_at = new Date();
            updatePais.created_at = created_at;
            const data = await this.paisRepository.save(updatePais);
            const formattedData = {
                ...data,
                created_at: (0, date_fns_1.format)(new Date(data.created_at), 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(new Date(data.updated_at), 'dd/MM/yyyy')
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Pais actualizado exitosamente',
            };
        }
    }
    async deleteData(id) {
        const rs = await this.paisRepository.createQueryBuilder()
            .update(pais_entity_1.Pais)
            .set({ deleted_at: () => 'CURRENT_TIMESTAMP' })
            .where('id = :id', { id })
            .execute();
        if (rs.affected === 0) {
            console.log(rs.affected);
            return new common_1.HttpException('Pais no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return rs;
        }
    }
};
exports.PaisService = PaisService;
exports.PaisService = PaisService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(pais_entity_1.Pais)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], PaisService);
//# sourceMappingURL=pais.service.js.map