"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PerfilService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const perfil_entity_1 = require("./perfil.entity");
const typeorm_2 = require("typeorm");
const date_fns_1 = require("date-fns");
let PerfilService = class PerfilService {
    constructor(perfilRepository) {
        this.perfilRepository = perfilRepository;
    }
    async getDataAll() {
        const perfil = await this.perfilRepository.createQueryBuilder('perfil')
            .leftJoinAndSelect('perfil.user', 'user')
            .where('perfil.deleted_at IS NULL')
            .andWhere('user.deleted_at IS NULL')
            .getMany();
        if (!perfil) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return perfil.map(perfil => ({
                ...perfil,
                created_at: (0, date_fns_1.format)(perfil.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(perfil.updated_at, 'dd/MM/yyyy'),
                user: perfil.user.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            }));
        }
    }
    async getData(page = 1, limit = 2) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const [data, total] = await this.perfilRepository.createQueryBuilder('perfil')
            .leftJoinAndSelect('perfil.user', 'user')
            .where('perfil.deleted_at IS NULL')
            .andWhere('user.deleted_at IS NULL')
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(perfil => ({
                ...perfil,
                created_at: (0, date_fns_1.format)(perfil.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(perfil.updated_at, 'dd/MM/yyyy'),
                user: perfil.user.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async searchData(page = 1, limit = 9, params) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const query = this.perfilRepository.createQueryBuilder('perfil')
            .leftJoinAndSelect('perfil.user', 'user')
            .where('perfil.deleted_at IS NULL')
            .andWhere('user.deleted_at IS NULL');
        if (params.nombre) {
            console.log('params:');
            console.log(params);
            query.andWhere('perfil.nombre LIKE :nombre', { nombre: `%${params.nombre}%` });
        }
        const [data, total] = await query
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        console.log('data:');
        console.log(data);
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(perfil => ({
                ...perfil,
                created_at: (0, date_fns_1.format)(perfil.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(perfil.updated_at, 'dd/MM/yyyy'),
                user: perfil.user.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            }));
            return {
                data: formattedData,
                message: 'Perfiles encontrados con éxito',
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async getDataById(id) {
        const perfil = await this.perfilRepository.createQueryBuilder('perfil')
            .leftJoinAndSelect('perfil.user', 'user')
            .where('perfil.deleted_at IS NULL')
            .andWhere('user.deleted_at IS NULL')
            .where('perfil.id = :id', { id })
            .getOne();
        if (!perfil) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return {
                ...perfil,
                created_at: (0, date_fns_1.format)(perfil.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(perfil.updated_at, 'dd/MM/yyyy'),
                user: perfil.user.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            };
        }
    }
    async createPerfil(perfil) {
        const perfilFound = await this.perfilRepository.findOne({
            where: {
                nombre: perfil.nombre,
                deleted_at: null
            }
        });
        if (perfilFound) {
            return new common_1.HttpException({
                status: common_1.HttpStatus.CONFLICT,
                message: 'Perfil ya existe',
            }, common_1.HttpStatus.CONFLICT);
        }
        else {
            const newPerfil = this.perfilRepository.create(perfil);
            const savedPerfil = await this.perfilRepository.save(newPerfil);
            const formattedData = {
                ...savedPerfil,
                created_at: (0, date_fns_1.format)(savedPerfil.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(savedPerfil.updated_at, 'dd/MM/yyyy'),
                user: savedPerfil.user
                    ? savedPerfil.user.map((us) => ({
                        ...us,
                        created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                        updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                    }))
                    : [],
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Perfil creado exitosamente',
            };
        }
    }
    async updateData(id, perfil) {
        const perfilFound = await this.perfilRepository.findOne({
            where: {
                id: id
            }
        });
        if (!perfilFound) {
            return new common_1.HttpException('Perfil no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const { created_at } = perfilFound;
            const updatePerfil = Object.assign(perfilFound, perfil);
            updatePerfil.updated_at = new Date();
            updatePerfil.created_at = created_at;
            const data = await this.perfilRepository.save(updatePerfil);
            const formattedData = {
                ...data,
                created_at: (0, date_fns_1.format)(data.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(data.updated_at, 'dd/MM/yyyy'),
                user: data.user.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Perfil actualizado exitosamente',
            };
        }
    }
    async deleteData(id) {
        const rs = await this.perfilRepository.createQueryBuilder()
            .update(perfil_entity_1.Perfil)
            .set({ deleted_at: () => 'CURRENT_TIMESTAMP' })
            .where('id = :id', { id })
            .execute();
        if (rs.affected === 0) {
            console.log(rs.affected);
            return new common_1.HttpException('Perfil no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return rs;
        }
    }
};
exports.PerfilService = PerfilService;
exports.PerfilService = PerfilService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(perfil_entity_1.Perfil)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], PerfilService);
//# sourceMappingURL=perfil.service.js.map