"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MatchPasswordsConstraint = void 0;
exports.IsMinLength = IsMinLength;
exports.ContainsNumber = ContainsNumber;
exports.ContainsLetter = ContainsLetter;
exports.ContainsSpecialCharacter = ContainsSpecialCharacter;
exports.IsEmailUnique = IsEmailUnique;
exports.IsEmailUniqueUpd = IsEmailUniqueUpd;
const class_validator_1 = require("class-validator");
const unique_validators_1 = require("../users/unique-validators");
const unique_validators_2 = require("../users/unique-validators");
let MatchPasswordsConstraint = class MatchPasswordsConstraint {
    validate(password_confirm, args) {
        const [relatedPropertyName] = args.constraints;
        const relatedValue = args.object[relatedPropertyName];
        return password_confirm === relatedValue;
    }
    defaultMessage(args) {
        return 'La confirmación de la contraseña no coincide con la contraseña';
    }
};
exports.MatchPasswordsConstraint = MatchPasswordsConstraint;
exports.MatchPasswordsConstraint = MatchPasswordsConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'MatchPasswords', async: false })
], MatchPasswordsConstraint);
function IsMinLength(min, validationOptions) {
    return function (object, propertyName) {
        (0, class_validator_1.registerDecorator)({
            name: 'isMinLength',
            target: object.constructor,
            propertyName: propertyName,
            constraints: [min],
            options: validationOptions,
            validator: {
                validate(value, args) {
                    return typeof value === 'string' && value.length >= args.constraints[0];
                },
                defaultMessage(args) {
                    return `La contraseña debe tener al menos ${args.constraints[0]} caracteres`;
                },
            },
        });
    };
}
function ContainsNumber(validationOptions) {
    return function (object, propertyName) {
        (0, class_validator_1.registerDecorator)({
            name: 'containsNumber',
            target: object.constructor,
            propertyName: propertyName,
            options: validationOptions,
            validator: {
                validate(value) {
                    return /\d/.test(value);
                },
                defaultMessage() {
                    return 'La contraseña debe incluir al menos un número';
                },
            },
        });
    };
}
function ContainsLetter(validationOptions) {
    return function (object, propertyName) {
        (0, class_validator_1.registerDecorator)({
            name: 'containsLetter',
            target: object.constructor,
            propertyName: propertyName,
            options: validationOptions,
            validator: {
                validate(value) {
                    return /[A-Za-z]/.test(value);
                },
                defaultMessage() {
                    return 'La contraseña debe incluir al menos una letra';
                },
            },
        });
    };
}
function ContainsSpecialCharacter(validationOptions) {
    return function (object, propertyName) {
        (0, class_validator_1.registerDecorator)({
            name: 'containsSpecialCharacter',
            target: object.constructor,
            propertyName: propertyName,
            options: validationOptions,
            validator: {
                validate(value) {
                    return /[@$!%*?&]/.test(value);
                },
                defaultMessage() {
                    return 'La contraseña debe incluir al menos un carácter especial';
                },
            },
        });
    };
}
function IsEmailUnique(validationOptions) {
    return function (object, propertyName) {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName: propertyName,
            options: validationOptions,
            constraints: [],
            validator: unique_validators_1.IsEmailUniqueConstraint,
        });
    };
}
function IsEmailUniqueUpd(validationOptions) {
    return function (object, propertyName) {
        (0, class_validator_1.registerDecorator)({
            target: object.constructor,
            propertyName: propertyName,
            options: validationOptions,
            constraints: [],
            validator: unique_validators_2.IsEmailUniqueConstraintUpd,
        });
    };
}
//# sourceMappingURL=custom-validators.js.map