"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileValidationPipe = void 0;
const common_1 = require("@nestjs/common");
let FileValidationPipe = class FileValidationPipe {
    transform(file, metadata) {
        const maxFileSize = 1_000_000;
        const maxFileSizeInMb = maxFileSize / 1_000_000;
        let valid = true;
        let error;
        console.log('archivo:');
        console.log(file);
        if (!file) {
            valid = false;
            error = new common_1.HttpException('No existe Archivo', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const allowedTypes = ['image/jpeg', 'image/png', 'image/webp'];
            if (!allowedTypes.includes(file.mimetype)) {
                valid = false;
                error = new common_1.HttpException('Tipo de archivo no permitido (image/jpeg, image/png, image/webp)', common_1.HttpStatus.UNSUPPORTED_MEDIA_TYPE);
            }
            if (file.size > maxFileSize) {
                valid = false;
                error = new common_1.HttpException(`Archivo demasiado pesado. Límite permitido: ${maxFileSizeInMb} MB`, common_1.HttpStatus.NOT_ACCEPTABLE);
            }
        }
        return valid ? file : error;
    }
};
exports.FileValidationPipe = FileValidationPipe;
exports.FileValidationPipe = FileValidationPipe = __decorate([
    (0, common_1.Injectable)()
], FileValidationPipe);
//# sourceMappingURL=fileValidator.js.map