"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileValidationPipeUpdate = void 0;
const common_1 = require("@nestjs/common");
let FileValidationPipeUpdate = class FileValidationPipeUpdate {
    transform(file, metadata) {
        const oneKb = 1000000;
        let valid = true;
        let error;
        if (!file) {
            valid = true;
            error = new common_1.HttpException('No existe Archivo', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const allowedTypes = ['image/jpeg', 'image/png', 'image/webp'];
            if (!allowedTypes.includes(file.mimetype)) {
                valid = false;
                error = new common_1.HttpException('Tipo de archivo no permitido', common_1.HttpStatus.UNSUPPORTED_MEDIA_TYPE);
            }
            if (file.size > oneKb) {
                valid = false;
                error = new common_1.HttpException('Archivo demasiado pesado', common_1.HttpStatus.NOT_ACCEPTABLE);
            }
        }
        return valid ? file : error;
    }
};
exports.FileValidationPipeUpdate = FileValidationPipeUpdate;
exports.FileValidationPipeUpdate = FileValidationPipeUpdate = __decorate([
    (0, common_1.Injectable)()
], FileValidationPipeUpdate);
//# sourceMappingURL=fileValidatorUpdate.js.map