"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProvinciaController = void 0;
const common_1 = require("@nestjs/common");
const provincia_service_1 = require("./provincia.service");
const create_provincia_dto_1 = require("./dto/create-provincia.dto");
const update_provincia_dto_1 = require("./dto/update-provincia.dto");
const common_2 = require("@nestjs/common");
const auth_guard_1 = require("../auth/auth.guard");
let ProvinciaController = class ProvinciaController {
    constructor(provinciaService) {
        this.provinciaService = provinciaService;
    }
    async getProvinciaByDepartamentoId(departamento_id) {
        try {
            const data = await this.provinciaService.getDataByDepartamentoId(departamento_id);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener tipo de vista', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getDepartamentoAll() {
        try {
            const data = await this.provinciaService.getDataAll();
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener tipo de vista', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getProvincia(page, limit) {
        if (page <= 0 || limit <= 0) {
            throw new common_1.HttpException('Los valores de página y límite deben ser mayores que 0', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.provinciaService.getData(page, limit);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener datos', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getProvinciaSearch(page, limit, body) {
        try {
            const { nombre, departamento_id } = body;
            console.log('Parámetros recibidos:', body);
            const data = await this.provinciaService.searchData(page, limit, {
                nombre, departamento_id
            });
            return {
                data,
            };
        }
        catch (error) {
            console.error('Error al buscar departamento:', error);
            throw new common_1.HttpException(error.message || 'Ocurrió un error al procesar la solicitud', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    getProvinciaById(id) {
        console.log(id);
        console.log(typeof id);
        return this.provinciaService.getDataById(id);
    }
    createProvincia(newProvincia) {
        return this.provinciaService.createData(newProvincia);
    }
    updateProvincia(id, provincia) {
        return this.provinciaService.updateData(id, provincia);
    }
    deleteProvincia(id) {
        return this.provinciaService.deleteData(id);
    }
};
exports.ProvinciaController = ProvinciaController;
__decorate([
    (0, common_1.Get)('byDepartment/:departamento_id'),
    __param(0, (0, common_1.Param)('departamento_id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], ProvinciaController.prototype, "getProvinciaByDepartamentoId", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)('provinciaAll'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ProvinciaController.prototype, "getDepartamentoAll", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], ProvinciaController.prototype, "getProvincia", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)('searchProvincia/:page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", Promise)
], ProvinciaController.prototype, "getProvinciaSearch", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ProvinciaController.prototype, "getProvinciaById", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_provincia_dto_1.CreateProvinciaDto]),
    __metadata("design:returntype", void 0)
], ProvinciaController.prototype, "createProvincia", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_provincia_dto_1.UpdateProvinciaDto]),
    __metadata("design:returntype", void 0)
], ProvinciaController.prototype, "updateProvincia", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ProvinciaController.prototype, "deleteProvincia", null);
exports.ProvinciaController = ProvinciaController = __decorate([
    (0, common_1.Controller)('provincia'),
    __metadata("design:paramtypes", [provincia_service_1.ProvinciaService])
], ProvinciaController);
//# sourceMappingURL=provincia.controller.js.map