"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TipoInmuebleController = void 0;
const common_1 = require("@nestjs/common");
const tipo_inmueble_service_1 = require("./tipo-inmueble.service");
const create_tipo_inmueble_dto_1 = require("./dto/create-tipo-inmueble.dto");
const update_tipo_inmueble_dto_1 = require("./dto/update-tipo-inmueble.dto");
const common_2 = require("@nestjs/common");
const auth_guard_1 = require("../auth/auth.guard");
let TipoInmuebleController = class TipoInmuebleController {
    constructor(tipoInmuebleService) {
        this.tipoInmuebleService = tipoInmuebleService;
    }
    async getTipoInmuebleAll() {
        try {
            const data = await this.tipoInmuebleService.getDataAll();
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener tipo de vista', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getTipoInmueble(page, limit) {
        if (page <= 0 || limit <= 0) {
            throw new common_1.HttpException('Los valores de página y límite deben ser mayores que 0', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.tipoInmuebleService.getData(page, limit);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener datos', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async searchTipoInmueble(page, limit, body) {
        try {
            const { nombre } = body;
            console.log('Parámetros recibidos:', body);
            const data = await this.tipoInmuebleService.searchData(page, limit, {
                nombre
            });
            return {
                data,
            };
        }
        catch (error) {
            console.error('Error al buscar tipo operacion:', error);
            throw new common_1.HttpException(error.message || 'Ocurrió un error al procesar la solicitud', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    getTipoInmuebleById(id) {
        console.log(id);
        console.log(typeof id);
        return this.tipoInmuebleService.getDataById(id);
    }
    createTipoInmueble(newTipoInmueble) {
        return this.tipoInmuebleService.createData(newTipoInmueble);
    }
    updateTipoInmueble(id, tipoInmueble) {
        return this.tipoInmuebleService.updateData(id, tipoInmueble);
    }
    deleteTipoInmueble(id) {
        return this.tipoInmuebleService.deleteData(id);
    }
};
exports.TipoInmuebleController = TipoInmuebleController;
__decorate([
    (0, common_1.Get)('tipoInmuebleAll'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TipoInmuebleController.prototype, "getTipoInmuebleAll", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], TipoInmuebleController.prototype, "getTipoInmueble", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)('searchTipoInmueble/:page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", Promise)
], TipoInmuebleController.prototype, "searchTipoInmueble", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TipoInmuebleController.prototype, "getTipoInmuebleById", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_tipo_inmueble_dto_1.CreateTipoInmuebleDto]),
    __metadata("design:returntype", void 0)
], TipoInmuebleController.prototype, "createTipoInmueble", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_tipo_inmueble_dto_1.UpdateTipoInmuebleDto]),
    __metadata("design:returntype", void 0)
], TipoInmuebleController.prototype, "updateTipoInmueble", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TipoInmuebleController.prototype, "deleteTipoInmueble", null);
exports.TipoInmuebleController = TipoInmuebleController = __decorate([
    (0, common_1.Controller)('tipo-inmueble'),
    __metadata("design:paramtypes", [tipo_inmueble_service_1.TipoInmuebleService])
], TipoInmuebleController);
//# sourceMappingURL=tipo-inmueble.controller.js.map