"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TipoInmuebleService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const tipo_inmueble_entity_1 = require("./tipo-inmueble.entity");
const typeorm_2 = require("typeorm");
const date_fns_1 = require("date-fns");
let TipoInmuebleService = class TipoInmuebleService {
    constructor(tipoInmuebleRepository) {
        this.tipoInmuebleRepository = tipoInmuebleRepository;
    }
    async getDataAll() {
        const tipoInmueble = await this.tipoInmuebleRepository.createQueryBuilder('tipo_inmueble')
            .andWhere('tipo_inmueble.deleted_at IS NULL')
            .getMany();
        if (!tipoInmueble.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return tipoInmueble.map(tipoInmueble => ({
                ...tipoInmueble,
                created_at: (0, date_fns_1.format)(tipoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoInmueble.updated_at, 'dd/MM/yyyy'),
            }));
        }
    }
    async getData(page = 1, limit = 2) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const [data, total] = await this.tipoInmuebleRepository.createQueryBuilder('tipo_inmueble')
            .andWhere('tipo_inmueble.deleted_at IS NULL')
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(tipoInmueble => ({
                ...tipoInmueble,
                created_at: (0, date_fns_1.format)(tipoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoInmueble.updated_at, 'dd/MM/yyyy'),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async searchData(page = 1, limit = 9, params) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const query = this.tipoInmuebleRepository.createQueryBuilder('tipo_inmueble')
            .andWhere('tipo_inmueble.deleted_at IS NULL');
        if (params.nombre) {
            console.log('params:');
            console.log(params);
            query.andWhere('tipo_inmueble.nombre LIKE :nombre', { nombre: `%${params.nombre}%` });
        }
        const [data, total] = await query
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        console.log('data:');
        console.log(data);
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(tipoInmueble => ({
                ...tipoInmueble,
                created_at: (0, date_fns_1.format)(tipoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoInmueble.updated_at, 'dd/MM/yyyy'),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async getDataById(id) {
        const tipoInmueble = await this.tipoInmuebleRepository.createQueryBuilder('tipo_inmueble')
            .andWhere('tipo_inmueble.deleted_at IS NULL')
            .where('tipo_inmueble.id = :id', { id })
            .getOne();
        if (!tipoInmueble) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return {
                ...tipoInmueble,
                created_at: (0, date_fns_1.format)(tipoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoInmueble.updated_at, 'dd/MM/yyyy'),
            };
        }
    }
    async createData(tipoInmueble) {
        const tipoInmuebleFound = await this.tipoInmuebleRepository.findOne({
            where: {
                nombre: tipoInmueble.nombre,
                deleted_at: null
            }
        });
        if (tipoInmuebleFound) {
            return new common_1.HttpException({
                status: common_1.HttpStatus.CONFLICT,
                message: 'Tipo de inmueble ya existe',
            }, common_1.HttpStatus.CONFLICT);
        }
        else {
            const newTipoInmueble = this.tipoInmuebleRepository.create(tipoInmueble);
            const savedTipoInmueble = await this.tipoInmuebleRepository.save(newTipoInmueble);
            const formattedData = {
                ...savedTipoInmueble,
                created_at: (0, date_fns_1.format)(savedTipoInmueble.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(savedTipoInmueble.updated_at, 'dd/MM/yyyy')
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Tipo de inmueble creado exitosamente',
            };
        }
    }
    async updateData(id, tipoInmueble) {
        const tipoInmuebleFound = await this.tipoInmuebleRepository.findOne({
            where: {
                id: id
            }
        });
        if (!tipoInmuebleFound) {
            return new common_1.HttpException('Tipo de inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const { created_at } = tipoInmuebleFound;
            const updateTipoInmueble = Object.assign(tipoInmuebleFound, tipoInmueble);
            updateTipoInmueble.updated_at = new Date();
            updateTipoInmueble.created_at = created_at;
            const data = await this.tipoInmuebleRepository.save(updateTipoInmueble);
            const formattedData = {
                ...data,
                created_at: (0, date_fns_1.format)(new Date(data.created_at), 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(new Date(data.updated_at), 'dd/MM/yyyy')
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Tipo de inmueble actualizado exitosamente',
            };
        }
    }
    async deleteData(id) {
        const rs = await this.tipoInmuebleRepository.createQueryBuilder()
            .update(tipo_inmueble_entity_1.TipoInmueble)
            .set({ deleted_at: () => 'CURRENT_TIMESTAMP' })
            .where('id = :id', { id })
            .execute();
        if (rs.affected === 0) {
            console.log(rs.affected);
            return new common_1.HttpException('Tipo inmueble no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return rs;
        }
    }
};
exports.TipoInmuebleService = TipoInmuebleService;
exports.TipoInmuebleService = TipoInmuebleService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(tipo_inmueble_entity_1.TipoInmueble)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], TipoInmuebleService);
//# sourceMappingURL=tipo-inmueble.service.js.map