import { HttpStatus, HttpException } from '@nestjs/common';
import { TipoMonedaService } from './tipo-moneda.service';
import { CreateTipoMonedaDto } from './dto/create-tipo-moneda.dto';
import { UpdateTipoMonedaDto } from './dto/update-tipo-moneda.dto';
export declare class TipoMonedaController {
    private tipoMonedaService;
    constructor(tipoMonedaService: TipoMonedaService);
    getTipoMonedaAll(): Promise<{
        statusCode: HttpStatus;
        message: string;
        data: HttpException | {
            created_at: string;
            updated_at: string;
            id: number;
            nombre: string;
            simbolo: string;
            deleted_at: Date;
            inmueble: import("../inmueble/inmueble.entity").Inmueble[];
        }[];
    }>;
    getTipoMoneda(page: number, limit: number): Promise<{
        statusCode: HttpStatus;
        message: string;
        data: HttpException | {
            data: {
                created_at: string;
                updated_at: string;
                id: number;
                nombre: string;
                simbolo: string;
                deleted_at: Date;
                inmueble: import("../inmueble/inmueble.entity").Inmueble[];
            }[];
            meta: {
                total: number;
                page: number;
                limit: number;
                totalPages: number;
            };
        };
    }>;
    getUserSearch(page: number, limit: number, body: Record<string, any>): Promise<{
        data: HttpException | {
            data: {
                created_at: string;
                updated_at: string;
                id: number;
                nombre: string;
                simbolo: string;
                deleted_at: Date;
                inmueble: import("../inmueble/inmueble.entity").Inmueble[];
            }[];
            meta: {
                total: number;
                page: number;
                limit: number;
                totalPages: number;
            };
        };
    }>;
    getTipoMonedaById(id: number): Promise<HttpException | {
        created_at: string;
        updated_at: string;
        id: number;
        nombre: string;
        simbolo: string;
        deleted_at: Date;
        inmueble: import("../inmueble/inmueble.entity").Inmueble[];
    }>;
    createTipoMoneda(newTipoMoneda: CreateTipoMonedaDto): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            id: number;
            nombre: string;
            simbolo: string;
            deleted_at: Date;
            inmueble: import("../inmueble/inmueble.entity").Inmueble[];
        };
        status: HttpStatus;
        message: string;
    }>;
    updateTipoMoneda(id: number, tipoMoneda: UpdateTipoMonedaDto): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            id: never;
            nombre: string;
            simbolo: string;
            deleted_at: Date;
            inmueble: import("../inmueble/inmueble.entity").Inmueble[];
        };
        status: HttpStatus;
        message: string;
    }>;
    deleteTipoMoneda(id: number): Promise<HttpException | import("typeorm").UpdateResult>;
}
