"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TipoOperacionController = void 0;
const common_1 = require("@nestjs/common");
const tipo_operacion_service_1 = require("./tipo-operacion.service");
const create_tipo_operacion_dto_1 = require("./dto/create-tipo-operacion.dto");
const update_tipo_operacion_dto_1 = require("./dto/update-tipo-operacion.dto");
const common_2 = require("@nestjs/common");
const auth_guard_1 = require("../auth/auth.guard");
let TipoOperacionController = class TipoOperacionController {
    constructor(tipoOperacionService) {
        this.tipoOperacionService = tipoOperacionService;
    }
    async getTipoVistaAll() {
        try {
            const data = await this.tipoOperacionService.getDataAll();
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener tipo de vista', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getTipoOperacion(page, limit) {
        if (page <= 0 || limit <= 0) {
            throw new common_1.HttpException('Los valores de página y límite deben ser mayores que 0', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.tipoOperacionService.getData(page, limit);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener datos', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getUserSearch(page, limit, body) {
        try {
            const { nombre } = body;
            console.log('Parámetros recibidos:', body);
            const data = await this.tipoOperacionService.searchData(page, limit, {
                nombre
            });
            return {
                data,
            };
        }
        catch (error) {
            console.error('Error al buscar tipo operacion:', error);
            throw new common_1.HttpException(error.message || 'Ocurrió un error al procesar la solicitud', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    getTipoOperacionById(id) {
        console.log(id);
        console.log(typeof id);
        return this.tipoOperacionService.getDataById(id);
    }
    createTipoOperacion(newTipoOperacion) {
        return this.tipoOperacionService.createData(newTipoOperacion);
    }
    updateTipoOperacion(id, tipoOperacion) {
        return this.tipoOperacionService.updateData(id, tipoOperacion);
    }
    deleteTipoOperacion(id) {
        return this.tipoOperacionService.deleteData(id);
    }
};
exports.TipoOperacionController = TipoOperacionController;
__decorate([
    (0, common_1.Get)('tipoOperacionAll'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TipoOperacionController.prototype, "getTipoVistaAll", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], TipoOperacionController.prototype, "getTipoOperacion", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)('searchTipoOperacion/:page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", Promise)
], TipoOperacionController.prototype, "getUserSearch", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TipoOperacionController.prototype, "getTipoOperacionById", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_tipo_operacion_dto_1.CreateTipoOperacionDto]),
    __metadata("design:returntype", void 0)
], TipoOperacionController.prototype, "createTipoOperacion", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_tipo_operacion_dto_1.UpdateTipoOperacionDto]),
    __metadata("design:returntype", void 0)
], TipoOperacionController.prototype, "updateTipoOperacion", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TipoOperacionController.prototype, "deleteTipoOperacion", null);
exports.TipoOperacionController = TipoOperacionController = __decorate([
    (0, common_1.Controller)('tipo-operacion'),
    __metadata("design:paramtypes", [tipo_operacion_service_1.TipoOperacionService])
], TipoOperacionController);
//# sourceMappingURL=tipo-operacion.controller.js.map