"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TipoUbicacionController = void 0;
const common_1 = require("@nestjs/common");
const tipo_ubicacion_service_1 = require("./tipo-ubicacion.service");
const create_tipo_ubicacion_dto_1 = require("./dto/create-tipo-ubicacion.dto");
const update_tipo_ubicacion_dto_1 = require("./dto/update-tipo-ubicacion.dto");
const common_2 = require("@nestjs/common");
const auth_guard_1 = require("../auth/auth.guard");
let TipoUbicacionController = class TipoUbicacionController {
    constructor(tipoUbicacionService) {
        this.tipoUbicacionService = tipoUbicacionService;
    }
    async getTipoVistaAll() {
        try {
            const data = await this.tipoUbicacionService.getDataAll();
            return {
                statusCode: data.status,
                message: data.data,
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener tipo de vista', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getTipoVista(page, limit) {
        if (page <= 0 || limit <= 0) {
            throw new common_1.HttpException('Los valores de página y límite deben ser mayores que 0', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.tipoUbicacionService.getData(page, limit);
            return {
                statusCode: data.status,
                message: data.data,
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener datos', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getUserSearch(page, limit, body) {
        try {
            const { nombre } = body;
            console.log('Parámetros recibidos:', body);
            const data = await this.tipoUbicacionService.searchData(page, limit, {
                nombre
            });
            return {
                data,
            };
        }
        catch (error) {
            console.error('Error al buscar tipo ubicación:', error);
            throw new common_1.HttpException(error.message || 'Ocurrió un error al procesar la solicitud', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    getTipoOperacionById(id) {
        console.log(id);
        console.log(typeof id);
        return this.tipoUbicacionService.getDataById(id);
    }
    createTipoOperacion(newTipoUbicacion) {
        return this.tipoUbicacionService.createData(newTipoUbicacion);
    }
    updateTipoOperacion(id, tipoUbicacion) {
        return this.tipoUbicacionService.updateData(id, tipoUbicacion);
    }
    deleteTipoOperacion(id) {
        return this.tipoUbicacionService.deleteData(id);
    }
};
exports.TipoUbicacionController = TipoUbicacionController;
__decorate([
    (0, common_1.Get)('tipoUbicacionAll'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TipoUbicacionController.prototype, "getTipoVistaAll", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], TipoUbicacionController.prototype, "getTipoVista", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)('searchTipoUbicacion/:page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", Promise)
], TipoUbicacionController.prototype, "getUserSearch", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TipoUbicacionController.prototype, "getTipoOperacionById", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_tipo_ubicacion_dto_1.CreateTipoUbicacionDto]),
    __metadata("design:returntype", void 0)
], TipoUbicacionController.prototype, "createTipoOperacion", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_tipo_ubicacion_dto_1.UpdateTipoUbicacionDto]),
    __metadata("design:returntype", void 0)
], TipoUbicacionController.prototype, "updateTipoOperacion", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TipoUbicacionController.prototype, "deleteTipoOperacion", null);
exports.TipoUbicacionController = TipoUbicacionController = __decorate([
    (0, common_1.Controller)('tipo-ubicacion'),
    __metadata("design:paramtypes", [tipo_ubicacion_service_1.TipoUbicacionService])
], TipoUbicacionController);
//# sourceMappingURL=tipo-ubicacion.controller.js.map