"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TipoUbicacionService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const tipo_ubicacion_entity_1 = require("./tipo-ubicacion.entity");
const typeorm_2 = require("typeorm");
const date_fns_1 = require("date-fns");
let TipoUbicacionService = class TipoUbicacionService {
    constructor(tipoUbicacionRepository) {
        this.tipoUbicacionRepository = tipoUbicacionRepository;
    }
    async getDataAll() {
        const tipoUbicacion = await this.tipoUbicacionRepository.createQueryBuilder('tipo_ubicacion')
            .where('tipo_ubicacion.deleted_at IS NULL')
            .getMany();
        if (!tipoUbicacion.length) {
            const error = new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
            return {
                error,
                status: common_1.HttpStatus.NOT_FOUND,
                message: 'No existen registros'
            };
        }
        else {
            const formattedData = tipoUbicacion.map(tipoUbicacion => ({
                ...tipoUbicacion,
                created_at: (0, date_fns_1.format)(tipoUbicacion.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoUbicacion.updated_at, 'dd/MM/yyyy'),
            }));
            return {
                data: formattedData,
                message: 'Datos obtenidos correctamente',
                status: common_1.HttpStatus.OK
            };
        }
    }
    async getData(page = 1, limit = 2) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const [data, total] = await this.tipoUbicacionRepository.createQueryBuilder('tipo_ubicacion')
            .andWhere('tipo_ubicacion.deleted_at IS NULL')
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        if (!data.length) {
            const error = new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
            return {
                error,
                status: common_1.HttpStatus.NOT_FOUND,
                message: 'No existen registros'
            };
        }
        else {
            const formattedData = data.map(tipoUbicacion => ({
                ...tipoUbicacion,
                created_at: (0, date_fns_1.format)(tipoUbicacion.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoUbicacion.updated_at, 'dd/MM/yyyy'),
            }));
            return {
                data: formattedData,
                message: 'Datos obtenidos correctamente',
                status: common_1.HttpStatus.OK,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async searchData(page = 1, limit = 9, params) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const query = this.tipoUbicacionRepository.createQueryBuilder('tipo_ubicacion')
            .andWhere('tipo_ubicacion.deleted_at IS NULL');
        if (params.nombre) {
            console.log('params:');
            console.log(params);
            query.andWhere('tipo_ubicacion.nombre LIKE :nombre', { nombre: `%${params.nombre}%` });
        }
        const [data, total] = await query
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        console.log('data:');
        console.log(data);
        if (!data.length) {
            const error = new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
            return {
                error,
                status: common_1.HttpStatus.NOT_FOUND,
                message: 'No existen registros'
            };
        }
        else {
            const formattedData = data.map(tipoUbicacion => ({
                ...tipoUbicacion,
                created_at: (0, date_fns_1.format)(tipoUbicacion.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoUbicacion.updated_at, 'dd/MM/yyyy'),
            }));
            return {
                data: formattedData,
                message: 'Datos obtenidos correctamente',
                status: common_1.HttpStatus.OK,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async getDataById(id) {
        const tipoUbicacion = await this.tipoUbicacionRepository.createQueryBuilder('tipo_ubicacion')
            .andWhere('tipo_ubicacion.deleted_at IS NULL')
            .where('tipo_ubicacion.id = :id', { id })
            .getOne();
        if (!tipoUbicacion) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return {
                ...tipoUbicacion,
                created_at: (0, date_fns_1.format)(tipoUbicacion.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoUbicacion.updated_at, 'dd/MM/yyyy'),
            };
        }
    }
    async createData(tipoUbicacion) {
        const tipoUbicacionFound = await this.tipoUbicacionRepository.findOne({
            where: {
                nombre: tipoUbicacion.nombre,
                deleted_at: null
            }
        });
        if (tipoUbicacionFound) {
            return new common_1.HttpException({
                status: common_1.HttpStatus.CONFLICT,
                message: 'Tipo de ubicación ya existe',
            }, common_1.HttpStatus.CONFLICT);
        }
        else {
            const newTipoUbicacion = this.tipoUbicacionRepository.create(tipoUbicacion);
            const savedTipoUbicacion = await this.tipoUbicacionRepository.save(newTipoUbicacion);
            const formattedData = {
                ...savedTipoUbicacion,
                created_at: (0, date_fns_1.format)(savedTipoUbicacion.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(savedTipoUbicacion.updated_at, 'dd/MM/yyyy')
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Tipo de ubicación creada exitosamente',
            };
        }
    }
    async updateData(id, tipoUbicacion) {
        const tipoUbicacionFound = await this.tipoUbicacionRepository.findOne({
            where: {
                id: id
            }
        });
        if (!tipoUbicacionFound) {
            return new common_1.HttpException('Tipo de ubicación no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const { created_at } = tipoUbicacionFound;
            const updateTipoUbicacion = Object.assign(tipoUbicacionFound, tipoUbicacion);
            updateTipoUbicacion.updated_at = new Date();
            updateTipoUbicacion.created_at = created_at ? created_at : new Date();
            const data = await this.tipoUbicacionRepository.save(updateTipoUbicacion);
            const formattedData = {
                ...data,
                created_at: (0, date_fns_1.format)(new Date(data.created_at), 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(new Date(data.updated_at), 'dd/MM/yyyy')
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Tipo de ubicación actualizado exitosamente',
            };
        }
    }
    async deleteData(id) {
        const rs = await this.tipoUbicacionRepository.createQueryBuilder()
            .update(tipo_ubicacion_entity_1.TipoUbicacion)
            .set({ deleted_at: () => 'CURRENT_TIMESTAMP' })
            .where('id = :id', { id })
            .execute();
        if (rs.affected === 0) {
            console.log(rs.affected);
            return new common_1.HttpException('Tipo ubicación no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return rs;
        }
    }
};
exports.TipoUbicacionService = TipoUbicacionService;
exports.TipoUbicacionService = TipoUbicacionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(tipo_ubicacion_entity_1.TipoUbicacion)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], TipoUbicacionService);
//# sourceMappingURL=tipo-ubicacion.service.js.map