import { HttpStatus, HttpException } from '@nestjs/common';
import { TipoVistaService } from './tipo-vista.service';
import { TipoVista } from './tipo-vista.entity';
import { CreateTipoVistaDto } from './dto/create-tipo-vista.dto';
import { UpdateTipoVistaDto } from './dto/update-tipo-vista.dto';
export declare class TipoVistaController {
    private tipoVistaService;
    constructor(tipoVistaService: TipoVistaService);
    getTipoVista(page: number, limit: number): Promise<{
        statusCode: HttpStatus;
        message: string;
        data: HttpException | {
            data: {
                created_at: string;
                updated_at: string;
                vista: {
                    created_at: string;
                    updated_at: string;
                    id: number;
                    nombre: string;
                    deleted_at: Date;
                    tipo_vista_id: number;
                    tipoVista: TipoVista;
                    inmuebleVistas: import("../inmueble-vistas/inmueble-vistas.entity").InmuebleVistas[];
                }[];
                id: number;
                nombre: string;
                deleted_at: Date;
            }[];
            meta: {
                total: number;
                page: number;
                limit: number;
                totalPages: number;
            };
        };
    }>;
    getTipoVistaAll(): Promise<{
        statusCode: HttpStatus;
        message: string;
        data: HttpException | {
            created_at: string;
            updated_at: string;
            vista: {
                created_at: string;
                updated_at: string;
                id: number;
                nombre: string;
                deleted_at: Date;
                tipo_vista_id: number;
                tipoVista: TipoVista;
                inmuebleVistas: import("../inmueble-vistas/inmueble-vistas.entity").InmuebleVistas[];
            }[];
            id: number;
            nombre: string;
            deleted_at: Date;
        }[];
    }>;
    getUserSearch(page: number, limit: number, body: Record<string, any>): Promise<{
        data: HttpException | {
            data: {
                created_at: string;
                updated_at: string;
                vista: {
                    created_at: string;
                    updated_at: string;
                    id: number;
                    nombre: string;
                    deleted_at: Date;
                    tipo_vista_id: number;
                    tipoVista: TipoVista;
                    inmuebleVistas: import("../inmueble-vistas/inmueble-vistas.entity").InmuebleVistas[];
                }[];
                id: number;
                nombre: string;
                deleted_at: Date;
            }[];
            meta: {
                total: number;
                page: number;
                limit: number;
                totalPages: number;
            };
        };
    }>;
    getTipoVistaById(id: number): Promise<HttpException | {
        created_at: string;
        updated_at: string;
        vista: {
            created_at: string;
            updated_at: string;
            id: number;
            nombre: string;
            deleted_at: Date;
            tipo_vista_id: number;
            tipoVista: TipoVista;
            inmuebleVistas: import("../inmueble-vistas/inmueble-vistas.entity").InmuebleVistas[];
        }[];
        id: number;
        nombre: string;
        deleted_at: Date;
    }>;
    createTipoVista(newTipoVista: CreateTipoVistaDto): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            vista: {
                created_at: string;
                updated_at: string;
                id: number;
                nombre: string;
                deleted_at: Date;
                tipo_vista_id: number;
                tipoVista: TipoVista;
                inmuebleVistas: import("../inmueble-vistas/inmueble-vistas.entity").InmuebleVistas[];
            }[];
            id: number;
            nombre: string;
            deleted_at: Date;
        };
        status: HttpStatus;
        message: string;
    }>;
    updateTipoVista(id: number, tipoVista: UpdateTipoVistaDto): Promise<HttpException | {
        data: {
            created_at: string;
            updated_at: string;
            id: number;
            nombre: string;
            deleted_at: Date;
            vista: import("../vista/vista.entity").Vista[] & string;
        };
        status: HttpStatus;
        message: string;
    }>;
    deleteTipoVista(id: number): Promise<HttpException | import("typeorm").UpdateResult>;
}
