"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TipoVistaService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const tipo_vista_entity_1 = require("./tipo-vista.entity");
const typeorm_2 = require("typeorm");
const date_fns_1 = require("date-fns");
let TipoVistaService = class TipoVistaService {
    constructor(tipoVistaRepository) {
        this.tipoVistaRepository = tipoVistaRepository;
    }
    async getDataAll() {
        const tipoVista = await this.tipoVistaRepository.createQueryBuilder('tipo_vista')
            .leftJoinAndSelect('tipo_vista.vista', 'vista', 'vista.deleted_at IS NULL')
            .where('tipo_vista.deleted_at IS NULL')
            .getMany();
        if (!tipoVista.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return tipoVista.map(tipoVista => ({
                ...tipoVista,
                created_at: (0, date_fns_1.format)(tipoVista.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoVista.updated_at, 'dd/MM/yyyy'),
                vista: tipoVista.vista.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            }));
        }
    }
    async getData(page = 1, limit = 2) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const [data, total] = await this.tipoVistaRepository.createQueryBuilder('tipo_vista')
            .leftJoinAndSelect('tipo_vista.vista', 'vista', 'vista.deleted_at IS NULL')
            .where('tipo_vista.deleted_at IS NULL')
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(tipoVista => ({
                ...tipoVista,
                created_at: (0, date_fns_1.format)(tipoVista.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoVista.updated_at, 'dd/MM/yyyy'),
                vista: tipoVista.vista.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async searchData(page = 1, limit = 9, params) {
        if (page < 1)
            page = 1;
        if (limit < 1)
            limit = 9;
        const offset = (page - 1) * limit;
        const query = this.tipoVistaRepository.createQueryBuilder('tipo_vista')
            .leftJoinAndSelect('tipo_vista.vista', 'vista', 'vista.deleted_at IS NULL')
            .where('tipo_vista.deleted_at IS NULL');
        if (params.nombre) {
            console.log('params:');
            console.log(params);
            query.andWhere('tipo_vista.nombre LIKE :nombre', { nombre: `%${params.nombre}%` });
        }
        const [data, total] = await query
            .skip(offset)
            .take(limit)
            .getManyAndCount();
        console.log('data:');
        console.log(data);
        if (!data.length) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const formattedData = data.map(tipoVista => ({
                ...tipoVista,
                created_at: (0, date_fns_1.format)(tipoVista.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoVista.updated_at, 'dd/MM/yyyy'),
                vista: tipoVista.vista.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            }));
            return {
                data: formattedData,
                meta: {
                    total,
                    page,
                    limit,
                    totalPages: Math.ceil(total / limit),
                },
            };
        }
    }
    async getDataById(id) {
        const tipoVista = await this.tipoVistaRepository.createQueryBuilder('tipo_vista')
            .leftJoinAndSelect('tipo_vista.vista', 'vista', 'vista.deleted_at IS NULL')
            .where('tipo_vista.deleted_at IS NULL')
            .where('tipo_vista.id = :id', { id })
            .getOne();
        if (!tipoVista) {
            return new common_1.HttpException('No existen registros', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return {
                ...tipoVista,
                created_at: (0, date_fns_1.format)(tipoVista.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(tipoVista.updated_at, 'dd/MM/yyyy'),
                vista: tipoVista.vista.map(us => ({
                    ...us,
                    created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                    updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                })),
            };
        }
    }
    async createTipoVista(tipoVista) {
        const tipoVistaFound = await this.tipoVistaRepository.findOne({
            where: {
                nombre: tipoVista.nombre,
                deleted_at: null
            }
        });
        if (tipoVistaFound) {
            return new common_1.HttpException({
                status: common_1.HttpStatus.CONFLICT,
                message: 'Tipo de vista ya existe',
            }, common_1.HttpStatus.CONFLICT);
        }
        else {
            const newTipoVista = this.tipoVistaRepository.create(tipoVista);
            const savedTipoVista = await this.tipoVistaRepository.save(newTipoVista);
            const formattedData = {
                ...savedTipoVista,
                created_at: (0, date_fns_1.format)(savedTipoVista.created_at, 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(savedTipoVista.updated_at, 'dd/MM/yyyy'),
                vista: savedTipoVista.vista
                    ? savedTipoVista.vista.map((us) => ({
                        ...us,
                        created_at: (0, date_fns_1.format)(new Date(us.created_at), 'dd/MM/yyyy'),
                        updated_at: (0, date_fns_1.format)(new Date(us.updated_at), 'dd/MM/yyyy'),
                    }))
                    : [],
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Tipo de vista creada exitosamente',
            };
        }
    }
    async updateData(id, tipoVista) {
        const tipoVistaFound = await this.tipoVistaRepository.findOne({
            where: {
                id: id
            },
            relations: ['vista'],
        });
        if (!tipoVistaFound) {
            return new common_1.HttpException('Tipo de vista no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            const { created_at } = tipoVistaFound;
            const updateTipoVista = Object.assign(tipoVistaFound, tipoVista);
            updateTipoVista.updated_at = new Date();
            updateTipoVista.created_at = created_at;
            const data = await this.tipoVistaRepository.save(updateTipoVista);
            const formattedData = {
                ...data,
                created_at: (0, date_fns_1.format)(new Date(data.created_at), 'dd/MM/yyyy'),
                updated_at: (0, date_fns_1.format)(new Date(data.updated_at), 'dd/MM/yyyy'),
            };
            return {
                data: formattedData,
                status: common_1.HttpStatus.OK,
                message: 'Tipo de vista actualizado exitosamente',
            };
        }
    }
    async deleteData(id) {
        const rs = await this.tipoVistaRepository.createQueryBuilder()
            .update(tipo_vista_entity_1.TipoVista)
            .set({ deleted_at: () => 'CURRENT_TIMESTAMP' })
            .where('id = :id', { id })
            .execute();
        if (rs.affected === 0) {
            console.log(rs.affected);
            return new common_1.HttpException('Tipo vista no encontrado', common_1.HttpStatus.NOT_FOUND);
        }
        else {
            return rs;
        }
    }
};
exports.TipoVistaService = TipoVistaService;
exports.TipoVistaService = TipoVistaService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(tipo_vista_entity_1.TipoVista)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], TipoVistaService);
//# sourceMappingURL=tipo-vista.service.js.map