"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsersController = void 0;
const common_1 = require("@nestjs/common");
const create_user_dto_1 = require("./dto/create-user.dto");
const users_service_1 = require("./users.service");
const update_user_dto_1 = require("./dto/update-user.dto");
const platform_express_1 = require("@nestjs/platform-express");
const fileValidator_1 = require("../pipes/fileValidator");
const fileValidatorUpdate_1 = require("../pipes/fileValidatorUpdate");
const uuid_1 = require("uuid");
const common_2 = require("@nestjs/common");
const auth_guard_1 = require("../auth/auth.guard");
let UsersController = class UsersController {
    constructor(usersService) {
        this.usersService = usersService;
    }
    uploadLogoHeader(file) {
        this.pathImage = '/imageUser';
        console.log(file);
        return file;
    }
    createUser(newUser) {
        return this.usersService.createUser(newUser);
    }
    async createUserImage(file, newUser) {
        this.pathImage = '/imageUser';
        if (file) {
            newUser.imagen = file.filename;
            return this.usersService.createUser(newUser);
        }
        else {
            console.log('file');
            console.log(file);
            return this.usersService.createUser(newUser);
        }
    }
    async getUser(page, limit) {
        if (page <= 0 || limit <= 0) {
            throw new common_1.HttpException('Los valores de página y límite deben ser mayores que 0', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.usersService.getData(page, limit);
            return {
                statusCode: data,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener usuarios', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    getValidaUserActive(id, token, horasValidas) {
        console.log(id);
        console.log(typeof id);
        return this.usersService.validaUserActive(id, token);
    }
    getUserById(id) {
        console.log(id);
        console.log(typeof id);
        return this.usersService.getDataById(id);
    }
    async getUserSearch(page, limit, body) {
        try {
            const { nombre, apellido, correo, perfil_id } = body;
            console.log('Parámetros recibidos:', body);
            const data = await this.usersService.searchData(page, limit, {
                nombre,
                apellido,
                correo,
                perfil_id
            });
            return {
                message: 'Usuarios encontrados con éxito',
                data,
            };
        }
        catch (error) {
            console.error('Error al buscar usuarios:', error);
            throw new common_1.HttpException(error.message || 'Ocurrió un error al procesar la solicitud', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    updateUserImage(id, file, user) {
        this.pathImage = '/imageUser';
        console.log(file);
        user.id = id;
        if (file) {
            user.imagen = file.filename;
            user.token = (0, uuid_1.v4)();
            console.log(id);
            console.log(typeof id);
            return this.usersService.updateData(id, user);
        }
        else {
            console.log('file: ' + file);
            user.token = (0, uuid_1.v4)();
            return this.usersService.updateData(id, user);
        }
    }
    updatePass(id, user) {
        return this.usersService.updatePass(id, user);
    }
    deleteUser(id) {
        return this.usersService.deleteData(id);
    }
    loginUser(correo, password) {
        return this.usersService.loginUser(correo, password);
    }
};
exports.UsersController = UsersController;
__decorate([
    (0, common_1.Post)('uploadImage'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('fileImageUser')),
    __param(0, (0, common_1.UploadedFile)(fileValidator_1.FileValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], UsersController.prototype, "uploadLogoHeader", null);
__decorate([
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_dto_1.CreateUserDto]),
    __metadata("design:returntype", void 0)
], UsersController.prototype, "createUser", null);
__decorate([
    (0, common_1.Post)('register'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('fileImageUser')),
    __param(0, (0, common_1.UploadedFile)(fileValidatorUpdate_1.FileValidationPipeUpdate)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_user_dto_1.CreateUserDto]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "createUserImage", null);
__decorate([
    (0, common_1.Get)(':page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "getUser", null);
__decorate([
    (0, common_1.Get)('validateUserActive/:id/:fechaActual/:horasValidas'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('token')),
    __param(2, (0, common_1.Param)('horasValidas', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, Number]),
    __metadata("design:returntype", void 0)
], UsersController.prototype, "getValidaUserActive", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], UsersController.prototype, "getUserById", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Post)('searchUser/:page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "getUserSearch", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Patch)(':id'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('fileImageUser')),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.UploadedFile)(fileValidatorUpdate_1.FileValidationPipeUpdate)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object, update_user_dto_1.UpdateUserDto]),
    __metadata("design:returntype", void 0)
], UsersController.prototype, "updateUserImage", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Patch)('updatePass/:id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_user_dto_1.UpdateUserDto]),
    __metadata("design:returntype", void 0)
], UsersController.prototype, "updatePass", null);
__decorate([
    (0, common_2.UseGuards)(auth_guard_1.AuthGuard),
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], UsersController.prototype, "deleteUser", null);
__decorate([
    (0, common_1.Post)('loginUser'),
    __param(0, (0, common_1.Body)('correo')),
    __param(1, (0, common_1.Body)('password')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", void 0)
], UsersController.prototype, "loginUser", null);
exports.UsersController = UsersController = __decorate([
    (0, common_1.Controller)('users'),
    __metadata("design:paramtypes", [users_service_1.UsersService])
], UsersController);
//# sourceMappingURL=users.controller.js.map