"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsersModule = void 0;
const common_1 = require("@nestjs/common");
const users_controller_1 = require("./users.controller");
const unique_validators_1 = require("./unique-validators");
const users_service_1 = require("./users.service");
const typeorm_1 = require("@nestjs/typeorm");
const user_entity_1 = require("./user.entity");
const perfil_entity_1 = require("../perfil/perfil.entity");
const platform_express_1 = require("@nestjs/platform-express");
const multer_1 = require("multer");
const uuid_1 = require("uuid");
const path = require("path");
const fs = require("fs");
const app_module_1 = require("../app.module");
const jwt_1 = require("@nestjs/jwt");
require("dotenv/config");
let UsersModule = class UsersModule {
};
exports.UsersModule = UsersModule;
exports.UsersModule = UsersModule = __decorate([
    (0, common_1.Module)({
        imports: [
            typeorm_1.TypeOrmModule.forFeature([user_entity_1.User, perfil_entity_1.Perfil]),
            platform_express_1.MulterModule.registerAsync({
                useFactory: () => ({
                    storage: (0, multer_1.diskStorage)({
                        destination: (req, file, cb) => {
                            const uploadPath = path.join('upload', file.fieldname);
                            fs.mkdirSync(uploadPath, { recursive: true });
                            cb(null, uploadPath);
                        },
                        filename: (req, file, cb) => {
                            const ext = path.extname(file.originalname);
                            const filename = `${(0, uuid_1.v4)()}${ext}`;
                            cb(null, filename);
                        },
                    }),
                }),
            }),
            (0, common_1.forwardRef)(() => app_module_1.AppModule),
            jwt_1.JwtModule.register({
                secret: process.env.JWT_SECRET || 'tu_clave_secreta',
                signOptions: { expiresIn: process.env.SESSION_TIME },
            }),
        ],
        controllers: [users_controller_1.UsersController],
        providers: [
            unique_validators_1.IsEmailUniqueConstraint,
            users_service_1.UsersService,
            {
                provide: 'SOME_NUMBER',
                useValue: 2
            }
        ],
        exports: [users_service_1.UsersService, jwt_1.JwtModule]
    })
], UsersModule);
//# sourceMappingURL=users.module.js.map