"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VistaController = void 0;
const common_1 = require("@nestjs/common");
const vista_service_1 = require("./vista.service");
const create_vista_dto_1 = require("./dto/create-vista.dto");
const update_vista_dto_1 = require("./dto/update-vista.dto");
let VistaController = class VistaController {
    constructor(vistaService) {
        this.vistaService = vistaService;
    }
    async getVistaByTipoVista(tipo_vista_id) {
        try {
            const data = await this.vistaService.getDataByTipoVistaId(tipo_vista_id);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener perfiles', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getVista(page, limit) {
        if (page <= 0 || limit <= 0) {
            throw new common_1.HttpException('Los valores de página y límite deben ser mayores que 0', common_1.HttpStatus.BAD_REQUEST);
        }
        try {
            const data = await this.vistaService.getData(page, limit);
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener perfiles', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getVistaAll() {
        try {
            const data = await this.vistaService.getDataAll();
            return {
                statusCode: common_1.HttpStatus.OK,
                message: 'Datos obtenidos correctamente',
                data,
            };
        }
        catch (error) {
            throw new common_1.HttpException(error.message || 'Error al obtener perfiles', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getVistaSearch(page, limit, body) {
        try {
            const { nombre, tipo_vista_id } = body;
            console.log('Parámetros recibidos:', body);
            const data = await this.vistaService.searchData(page, limit, {
                nombre, tipo_vista_id
            });
            return {
                data,
            };
        }
        catch (error) {
            console.error('Error al buscar perfiles:', error);
            throw new common_1.HttpException(error.message || 'Ocurrió un error al procesar la solicitud', error.status || common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    getVistaById(id) {
        console.log(id);
        console.log(typeof id);
        return this.vistaService.getDataById(id);
    }
    createVista(newVista) {
        return this.vistaService.createVista(newVista);
    }
    updateVista(id, vista) {
        return this.vistaService.updateData(id, vista);
    }
    deleteVista(id) {
        return this.vistaService.deleteData(id);
    }
};
exports.VistaController = VistaController;
__decorate([
    (0, common_1.Get)('byTipoVista/:tipo_vista_id'),
    __param(0, (0, common_1.Param)('tipo_vista_id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], VistaController.prototype, "getVistaByTipoVista", null);
__decorate([
    (0, common_1.Get)(':page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], VistaController.prototype, "getVista", null);
__decorate([
    (0, common_1.Get)('vistaAll'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], VistaController.prototype, "getVistaAll", null);
__decorate([
    (0, common_1.Post)('searchVista/:page/:limit'),
    __param(0, (0, common_1.Param)('page', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Param)('limit', common_1.ParseIntPipe)),
    __param(2, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", Promise)
], VistaController.prototype, "getVistaSearch", null);
__decorate([
    (0, common_1.Get)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VistaController.prototype, "getVistaById", null);
__decorate([
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_vista_dto_1.CreateVistaDto]),
    __metadata("design:returntype", void 0)
], VistaController.prototype, "createVista", null);
__decorate([
    (0, common_1.Patch)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_vista_dto_1.UpdateVistaDto]),
    __metadata("design:returntype", void 0)
], VistaController.prototype, "updateVista", null);
__decorate([
    (0, common_1.Put)(':id'),
    __param(0, (0, common_1.Param)('id', common_1.ParseIntPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VistaController.prototype, "deleteVista", null);
exports.VistaController = VistaController = __decorate([
    (0, common_1.Controller)('vista'),
    __metadata("design:paramtypes", [vista_service_1.VistaService])
], VistaController);
//# sourceMappingURL=vista.controller.js.map